#include <bits/stdc++.h>
#define pb push_back
using namespace std;
int p[500005];
int sz[500005];
vector<int> gr[300005];

int ffind(int v) {
    if(p[v] == v) {
        return v;
    }
    int r = ffind(p[v]);
    p[v] = r;
    return r;
}

void join(int u, int v) {
    u = ffind(u);
    v = ffind(v);
    if (u == v) {
        return;
    }
    if (u < v) {
        p[v] = u;
        sz[u] += sz[v];
        for (auto i : gr[v]) {
            gr[u].pb(i);
        }
        sort(gr[u].begin(), gr[u].end());
    }
    else {
        p[u] = v;
        sz[v] += sz[u];
        for (auto i : gr[u]) {
            gr[v].pb(i);
        }
        sort(gr[v].begin(), gr[v].end());
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    for (int i = 1; i <= n; i++) {
        p[i] = i;
        sz[i] = 1;
        gr[i].pb(i);
    }
    if (g == 1) {
        while (q) {
            q--;
            int c, a, b;
            cin >> c >> a >> b;
            if (b == 1) {
                cout << a;
            }
            else {
                cout << -1;
            }
            cout << "\n";
        }
    }
    for (int p = 0; p < q; p++) {
        int c, a, b;
        cin >> c;
        if (c == 2) {
            cin >> a >> b;
            join(a, b);
        }
        if (c == 1) {
            cin >> a >> b;
            int pr = ffind(a);
            if (gr[pr].size() < b) {
                cout << -1 << "\n";
            }
            else {
                cout << gr[pr][b - 1] << "\n";
            }
        }
    }
    return 0;
}
