#include <bits/stdc++.h>
using namespace std;

vector<int> sum(vector<vector<int>> tree)
{
    vector<int> sums(tree.size());
    for (int i = 0; i < tree.size(); i++)
    {
        for (int j = 0; j < tree.size(); j++)
            sums[i] += tree[i][j];
    }
    return sums;
}

int request(vector<vector<int>> tree, int k)
{
    vector<int> sums = sum(tree);
    int maxim = 0;
    int pointer = 0;
    for (int i = 0; i < sums.size(); i++)
    {
        if(maxim != max(sums[i], maxim))
            pointer = i;
        maxim = max(sums[i], maxim);
    }
    
    int counter = 0;
    while(accumulate(sums.begin(), sums.end(), 0) > 2 * k)
    {
        for(int i = 0; i < tree.size(); i++)
        {
            tree[pointer][i] = 0;
            tree[i][pointer] = 0;
        }
        sums = sum(tree);
        int maxim = 0;
        int pointer = 0;
        for (int i = 0; i < sums.size(); i++)
        {
            if(maxim != max(sums[i], maxim))
                pointer = i;
            maxim = max(sums[i], maxim);
        }        
        counter ++;
    }
    
    return counter;
}

int main() {
    int n, m, g;
    cin >> n >> m >> g;
    vector<vector<int>> tree(n, vector<int>(n));

    int u, v, c;
    for (int i = 0; i < n - 1; i++)
    {
        cin >> u >> v >> c;
        tree[u - 1][v - 1] = c;
        tree[v - 1][u - 1] = c;
    }

    for (int i = 0; i < m; i++)
    {
        int k;
        cin >> k;
        cout << request(tree, k) << ' ';
    }
}
