import math
import random

n, k, g = [int(x) for x in input().split()]
color = [int(x) for x in input().split()]

def valid(arr):
    count = [0]*max(arr)
    for i in arr:
        count[i-1] += 1
    if(sum(count)-2*max(count) < -2):
        return(False)
    else:
        return(True)

def correct(arr, center):
    if(arr[center] not in [arr[0], arr[center-1], arr[-1], arr[center+1]]):
        for i in range(len(arr)-1):
            if(arr[i] == arr[i+1]):
                return False
    else:
        return(False)
    return True

def change(arr, center):
    i = 0
    while i < len(arr)-1:
        if(arr[i] == arr[i+1]):
            arr[i], arr[i+1] = arr[i+1], arr[i]
            i += 1
            ind = round(center/arr.count(arr[i]))
            arr[i], arr[ind] = arr[ind], arr[i]
        i += 1
    center = (center+random.choice(range(-len(arr), len(arr))))%(len(arr)-4)+2
    return(arr, center)

def format_a(arr, center):
    upper = arr[0:center]
    bottom = arr[center+1:len(arr)]
    print(len(upper), len(bottom))
    print(' '.join([str(x) for x in upper]))
    print(arr[center])
    print(' '.join([str(x) for x in bottom]))

if(valid(color)):         
    center = math.ceil(len(color)/2)-1
    while not correct(color, center):
        color, center = change(color, center)
    format_a(color, center)
else:
    print(-1)