#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;


const int N = 5 * 1e5 + 11;
int p[N], sz[N];
tree < int , null_type , less < int > , rb_tree_tag , tree_order_statistics_node_update > ost[N];

int fndp (int x) {
    if (p[x] == x) return x;
    return p[x] = fndp (p[x]);
}

void unite (int a, int b) {
    a = fndp (a);
    b = fndp (b);
    if (a == b) return ;
    if (sz[a] < sz[b])
        swap (a, b);
    p[b] = a;
    sz[a] += sz[b];
    for (int i : ost[b])
        ost[a].insert (i);
    return ;
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    for (int i = 1; i <= n; ++i) {
        sz[i] = 1, p[i] = i;
        ost[i].insert (i);
    }
    while (q--) {
        int t, v, u;
        cin >> t >> v >> u;
        if (t == 3) return 3;
        if (t == 1) {
            v = fndp (v);
            if (ost[v].size() >= u) cout << *(ost[v].find_by_order (u - 1)) << "\n";
            else cout << "-1\n";
        }
        else
            unite (v, u);
    }

    return 0;
}
