#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define fi first
#define se second

const int nmax=334812;

int mas[nmax];
pair<int,int> tree[nmax*4];
vector<pair<int,int>> vc;
vector<int> a1,a2,fl;
map<int,int> mp;

pair<int,int> sum(pair<int,int> a,pair<int,int> b)
{
    //cout << a.fi << " " << a.se << " " << b.fi << " " << b.se << " a b\n";
    if(mas[a.fi]<mas[b.fi])
        swap(a,b);
    pair<int,int> ans;
    ans.fi=a.fi;
    if(mas[a.se]>mas[b.fi])
        ans.se=a.se;
    if(mas[a.se]<mas[b.fi])
        ans.se=b.fi;
    if(mas[a.se]==mas[b.fi])
        ans.se=min(a.se,b.fi);
    //cout << ans.fi << " " << ans.se << " ans\n";
    return ans;
}

void build(int v,int l,int r)
{
    if(l==r)
    {
        tree[v]={l,nmax-3};
        return ;
    }
    int m=(l+r)>>1;
    build(v+v,l,m);
    build(v+v+1,m+1,r);
    tree[v]=sum(tree[v+v],tree[v+v+1]);
}

pair<int,int> query()
{
    return tree[1];
}

void upd(int v,int l,int r,int ind)
{
    if(l==r)
        return ;
    int m=(l+r)>>1;
    if(ind<=m)
        upd(v+v,l,m,ind);
    else
        upd(v+v+1,m+1,r,ind);
    tree[v]=sum(tree[v+v+1],tree[v+v]);
    return ;
}

pair<int,int> fun()
{
    pair<int,int> ans=query();
    //cout << ans.fi << " " << ans.se << "\n";
    return ans;
}

bool check(int i1,int i2)
{
    if(fl[i1]==fl[i2])
        return 0;
    if(i1>0 && fl[i2]==fl[i1-1])
        return 0;
    if(i1+1<fl.size() && fl[i2]==fl[i1+1])
        return 0;
    swap(i1,i2);
    if(i1>0 && fl[i2]==fl[i1-1])
        return 0;
    if(i1+1<fl.size() && fl[i2]==fl[i1+1])
        return 0;
    return 1;
}

bool ok()
{
    int n=fl.size();
    for(int i=1;i<n;i++)
        if(fl[i]==fl[i-1])
            return 0;
    return 1;
}

int main()
{
    int n,k,g,t,ansp;
    cin >> n >> k >> g;
    for(int i=0;i<n;i++)
    {
        cin >> t;
        mp[t]++;
    }
    for(auto i:mp)
        vc.pb({i.se,i.fi});
    sort(vc.begin(),vc.end(),greater<>());
    for(int i=0;i<vc.size();i++)
        mas[i]=vc[i].fi;
    if(k==1)
    {
        cout << "-1\n";
        return 0;
    }
    mas[nmax-3]=-1;
    build(1,0,k-1);
    ansp=vc.back().se;
    pair<int,int> tm;
    fl.pb(ansp);
    for(int i=0;i<n;i++)
    {
        tm=fun();
        if(fl.back()!=vc[tm.fi].se)
        {
            fl.pb(vc[tm.fi].se);
            mas[tm.fi]--;
            upd(1,0,k-1,tm.fi);
            vc[tm.fi].fi--;
        }
        else
        {
            if(vc[tm.se].fi==0)
            {
                cout << "-1\n";
                return 0;
            }
            fl.pb(vc[tm.se].se);
            mas[tm.se]--;
            upd(1,0,k-1,tm.se);
            vc[tm.se].fi--;
        }
    }
    /*for(int i:fl)
        cout << i << " ";
    cout << "\n";*/
    reverse(fl.begin(),fl.end());
    fl.pop_back();
    reverse(fl.begin(),fl.end());
    if(fl.back()==ansp)
        for(int i=2;i<n-1;i++)
            if(check(i,n-1))
            {
                swap(fl[i],fl[n-1]);
                break;
            }
    if(fl[n-2]==ansp)
    {
        for(int i=2;i<n-2;i++)
            if(check(i,n-2))
            {
                swap(fl[i],fl[n-2]);
                break;
            }
    }
    /*for(int i:fl)
        cout << i << " ";
    cout << "\n";*/
    if(g<8 && fl.back()==ansp || fl[0]==ansp)
    {
        cout << "-1\n";
        return 0;
    }
    if(g==8 && fl.back()==ansp || fl[0]==ansp)
    {
        assert(0);
        cout << "-1\n";
        return 0;
    }
    assert(ok());
    int pos=0;
    while(pos<2 || fl[pos]!=ansp)
    {
        a1.pb(fl[pos]);
        pos++;
    }
    pos++;
    while(pos<n)
        a2.pb(fl[pos++]);
    if(a1.size()<2 || a2.size()<2)
    {
        cout << "-1\n";
        return 0;
    }
    cout << a1.size() << " " << a2.size() << "\n";
    for(int i:a1)
        cout << i << " ";
    cout << "\n";
    cout << ansp << "\n";
    for(int i:a2)
        cout << i << " ";
    cout << "\n";
    return 0;
}

/*
10 3 0
1 1 1 1 2 2 2 3 3 3
*/
