//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

#define int long long
#define fi first
#define se second

vector<pair<vector<int>, vector<int>>> ans;
vector<vector<pair<int, int>>> adj;
vector<int> sz;
pair<vector<int>, vector<int>> tans;


void dfs(int v, int p)
{
	int siz = 1;
	for (int i = 0; i < adj[v].size(); ++i)
	{
		if (adj[v][i].fi == p) continue;
		int to = adj[v][i].fi;
		dfs(to, v);
		tans = ans[v];
		for (int j = 0; j <= sz[to]; ++j)
		{
			for (int k = siz - 1; k >= 0; --k)
			{
				if(j >= 1) tans.first[j + k] = max(tans.first[j + k], ans[v].first[k] + max(ans[to].first[j], ans[to].second[j] + adj[v][i].se));
				else tans.first[j + k] = max(tans.first[j + k], ans[v].first[k] + ans[to].first[j]);
				if (j >= 1) tans.second[j + k + 1] = max(tans.second[j + k + 1], ans[v].second[k + 1] + adj[v][i].second + max(ans[to].first[j], ans[to].second[j]));
				else tans.second[j + k + 1] = max(tans.second[j + k + 1], ans[v].second[k + 1] + adj[v][i].second + ans[to].first[j]);
			}
		}
		ans[v] = tans;
		/*for (int j = 0; j <= adj.size(); ++j)
		{
			cout << ans[v].first[j] << " ";
		}
		cout << '\n';
		for (int j = 0; j <= adj.size(); ++j)
		{
			cout << ans[v].se[j] << " ";
		}
		cout << '\n';*/
		siz += sz[to];
	}
	
	sz[v] = siz;
}

int bins(int l, int r, int val)
{
	if (l == r) return l;
	int m = (l + r) >> 1;
	if (max(ans[0].fi[m], ans[0].second[m]) >= val) return bins(l, m, val);
	else return bins(m + 1, r, val);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, g, c1, c2, c3, sum = 0;
	cin >> n >> m >> g;
	ans.resize(n, {vector<int>(n + 1), vector<int>(n + 1)});
	adj.resize(n);
	sz.resize(n);
	for (int i = 0; i < (n - 1); ++i)
	{
		cin >> c1 >> c2 >> c3;
		--c1;
		--c2;
		adj[c1].push_back({ c2, c3 });
		adj[c2].push_back({ c1, c3 });
		sum += c3;
	}
	dfs(0, 0);
	for (int i = 0; i < m; ++i)
	{
		cin >> c1;
		c1 = sum - c1;
		cout << bins(0, n, c1) << " ";
	}
	cout << '\n';
	return 0;
}

/*

*/