#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int n, q, g;
vector<vector<int> > graph;
vector<int> cur_comp;
vector<bool> vis(500'001);

void dfs(int v)
{
    cur_comp.push_back(v);

    vis[v]=1;
    for(auto u: graph[v]){
        if(!vis[u]){
            dfs(u);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n >> q >> g;

	if(g==1){
        while(q--){
            int t, v, k;
            cin >> t >> v >> k;
            if(k==1){
                cout << v << '\n';
            }
            else{
                cout << -1 << '\n';
            }
        }
        return 0;
	}

	if(g==2){
        graph.resize(n+1);
        while(q--){
            int t;
            cin >> t;
            if(t==1){
                int v, k;
                cin >> v >> k;
                cur_comp.clear();
                vis.assign(n+1, 0);
                dfs(v);
                sort(cur_comp.begin(), cur_comp.end());
                cout << (k>cur_comp.size()? -1: cur_comp[k-1]) << '\n';
            }
            else{
                int u, v;
                cin >> u >> v;
                graph[u].push_back(v);
                graph[v].push_back(u);
            }
        }
        return 0;
	}

	if(g==0 || g==3){
        graph.resize(n+1);
        vector<vector<vector<int> > > mem(q+1);

        mem[0]=graph;

        for(int i=1; i<=q; i++){
            int t;
            cin >> t;
            if(t==1){
                int v, k;
                cin >> v >> k;
                cur_comp.clear();
                vis.assign(n+1, 0);
                dfs(v);
                sort(cur_comp.begin(), cur_comp.end());
                cout << (k>cur_comp.size()? -1: cur_comp[k-1]) << '\n';
            }
            else if(t==2){
                int u, v;
                cin >> u >> v;
                graph[u].push_back(v);
                graph[v].push_back(u);
            }
            else{
                int x;
                cin >> x;
                graph=mem[x];
            }
            mem[i]=graph;
        }
        return 0;
	}
}
