from math import *
from queue import *
from itertools import *
from copy import *


def read_line_int():
    return list(map(lambda x: int(x), input().split()))


class Graph():
    def __init__(self, vin):
        self.v = vin
        self.edges = []
        self.weights = {}
        self.power=0

    def add_edge(self, a, b, w):
        self.edges.append([a, b, w])

    def weight(self):
        q = self.weights.keys()
        for i in self.edges:
            if str(i[0]) not in q:
                self.weights[str(i[0])] = i[2]
                if str(i[1]) not in q:
                    self.weights[str(i[1])] = i[2]
                else:
                    self.weights[str(i[1])] += i[2]
            else:
                self.weights[str(i[0])] += i[2]
                if str(i[1]) not in q:
                    self.weights[str(i[1])] = i[2]
                else:
                    self.weights[str(i[1])] += i[2]
        for edge in self.edges:
            self.power+=edge[2]

    def solve(self, k):
        weights = deepcopy(self.weights)
        weights=list(map(lambda x:[x[0],x[1]],weights.items()))
        edges = deepcopy(self.edges)
        weights.sort(key=lambda x:x[0])
        total = deepcopy(self.power)
        res=0
        while (total>k):
            maxV=max(weights,key=lambda x:x[1])
            total-=maxV[1]
            res+=1
            for edge in edges:
                if edge[0]==int(maxV[0]) or edge[1]==int(maxV[0]):
                    if (edge[0]==int(maxV[0])):
                        weights[edge[1]-1][1]-=edge[2]
                    else:
                        weights[edge[0] - 1][1] -= edge[2]
                    edges.remove(edge)
        return res

a=read_line_int()
test = Graph(a[0])
for i in range(a[0]-1):
    a=read_line_int()
    test.add_edge(a[0],a[1],a[2])
test.weight()
xd = read_line_int()
print(' '.join(list(map(lambda x:str(test.solve(x)),xd))))