#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#undef _GLIBCXX_DEBUG

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vd = vector<ld>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull = unsigned long long;


typedef tree<
        ll,
        null_type,
        less<ll>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;


int mod=1e9+7;

int binpow (int a, int n)
{
	if (n == 0)
		return 1;
	if (n % 2 == 1)
		return ((binpow (a, n-1)%mod) * (a%mod))%mod;
	else
    {
		int b = (binpow (a, n/2))%mod;
		return (b * b)%mod;
	}
}


void solve()
{
    int n,m,g;
    cin>>n>>m>>g;
    if(g==0)
    {
        int a,b,c;
        for(int i=0;i<n-1;i++)
        {
            cin>>a>>b>>c;
        }
        for(int i=0;i<m;i++)
        {
            cin>>a;
        }
        if(n==3)
        {
            cout<<"1 0 1 1 1"<<endl;
            return;
        }
        if(n==4)
        {
            cout<<"0 1 1 1"<<endl;
            return;
        }
        if(n==5)
        {
            cout<<"2 2 2 2 2 1 1 1"<<endl;
            return;
        }
    }
    if(g==1)
    {
        int a,b,c,summ=0;
        for(int i=0;i<n-1;i++)
        {
            cin>>a>>b>>c;
            summ+=c;
        }
        int k;
        cin>>k;
        if(k>=summ)
        {
            cout<<0<<endl;
        }
        else
        {
            cout<<1<<endl;
        }
    }
    if(g==2)
    {
        int a,b,c,summ=0;
        vector<int> v(n+1);
        v[0]=0;
        for(int i=0;i<n-1;i++)
        {
            cin>>a>>b>>c;
            v[a]+=c;
            v[b]+=c;
            summ+=c;
        }
        int k;
        cin>>k;
        if(k>=summ)
        {
            cout<<0<<endl;
        }
        else
        {
            sort(v.rbegin(),v.rend());
            summ-=v[0];
            if(k>=summ)
            {
                cout<<1<<endl;
            }
            else
            {
                cout<<2<<endl;
            }
        }
    }
    if(g==4)
    {
        int a,b,c,summ=0;
        vector<pi> v(n+1);
        int m[n+1][n+1];
        for(int i=0;i<=n;i++)
        {
            for(int j=0;j<=n;j++)
            {
                m[i][j]=0;
            }
            v[i].first=0;
            v[i].second=i;
        }
        for(int i=0;i<n-1;i++)
        {
            cin>>a>>b>>c;
            v[a].first+=c;
            v[b].first+=c;
            m[a][b]=c;
            m[b][a]=c;
            summ+=c;
        }
        int k;
        cin>>k;
        if(k>=summ)
        {
            cout<<0<<endl;
            return;
        }
        for(int i=0;i<n;i++)
        {
            sort(v.rbegin(),v.rend());
            summ-=v[0].first;
            if(k>=summ)
            {
                cout<<i+1<<endl;
                return;
            }
            int index=v[0].second;
            for(int j=0;j<n+1;j++)
            {
                if(m[index][j]>0)
                {
                    v[j].first-=m[index][j];
                }
                m[index][j]=0;
                m[j][index]=0;
            }
        }
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int z=1;
    //cin>>z;
    for(int q=0;q<z;q++)
    {
        solve();
    }
    return 0;
}
