#include <bits/stdc++.h>
using namespace std;

vector<int> hey;

void rearrangeArray(vector<int>arr)
{
     int N = arr.size();
    // Store frequencies of all elements
    // of the array
    map<int, int>mp, visited;
     
    for(int i = 0; i < N; i++)
    {
        mp[arr[i]]++;
    }
     
    priority_queue<pair<int, int>>pq;
     
    // Adding high freq elements
    // in descending order
    for(int i = 0; i < N ; i++)
    {
        int val = arr[i];
         
        if (mp[val] > 0 and visited[val] != 1)
        {
            pq.push({mp[val], val});
        }
        visited[val] = 1;
    }
     
    // 'result[]' that will store resultant value
    vector<int>result(N);
     
    // Work as the previous visited element
    // initial previous element will be ( '-1' and
    // it's frequency wiint also be '-1' )
    pair<int, int>prev = { -1, -1 };
    int l = 0;
     
    // Traverse queue
    while (pq.size() != 0)
    {
         
        // Pop top element from queue and add it
        // to result
        pair<int,int>k = pq.top();
        pq.pop();
        result[l] = k.second;
         
        // If frequency of previous element is less
        // than zero that means it is useless, we
        // need not to push it
        if (prev.first > 0)
        {
            pq.push(prev);
        }
         
        // Make current element as the previous
        // decrease frequency by 'one'
        k.first--;
        prev = k;
        l++;
    }
     
    for(auto it : result)
    {
        if (it == 0)
        {
             
            // If found 0, No valid result
            // array possible
            cout << -1 << endl;
            return;
        }
    }
     
    for(auto it : result)
    {
       hey.push_back(it);
    }
}

int main() {
    vector<int>a;
    int n,k,g;
    cin>>n>>k>>g;
    for(int i = 0; i<n; i++)
    {
        int ki;
        cin>>ki;
        a.push_back(ki);
    }
    rearrangeArray(a);

    for(int i = 1; i<hey.size(); i++)
    {
        if(hey[i]==hey[i-1])
        {
            cout<<-1<<endl;
            return 0;
        }
    }


}
