#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>

using namespace std;

vector<pair<int, int>> lixt;
vector<int> inpl;
int n, k, g;
vector<int> ar;

int findnq(int prev)
{
    for (int i = 0; i < lixt.size(); i++)
    {
        if (lixt[i].second != prev)
        {
            lixt[i].first--;
            return lixt[i].second;
        }
    }
}

void M45()
{
    int exps = ((n - 1) / 2) - 1;
    if ((n % 2 == 0) || (exps < 2) || (abs(lixt[0].first - lixt[1].first) != 1))
    {
        cout << -1;
    }
    else
    {
        int st;
        if ((((n - 1) / 2) % 2) == 1) st = ((n - 1) / 2);
        else st = exps;
        vector<int> top = vector<int>(st);
        vector<int> bottom = vector<int>(n - st - 1);
        for (int i = 0; i < top.size(); i++)
        {
            if (i % 2 == 0)
            {
                top[i] = lixt[0].second;
            }
            else top[i] = lixt[1].second;
        }
        for (int i = 0; i < bottom.size(); i++)
        {
            if (i % 2 == 0)
            {
                bottom[i] = lixt[0].second;
            }
            else bottom[i] = lixt[1].second;
        }
        cout << top.size() << " " << bottom.size() << "\n";
        for (int i = 0; i < top.size(); i++)
        {
            cout << top[i] + 1 << " ";
        }
        cout << "\n" << lixt[1].second+1 << "\n";
        for (int i = 0; i < bottom.size(); i++)
        {
            cout << bottom[i] + 1 << " ";
        }
    }
}

int main()
{
    cin >> n >> k >> g;
    //<count, type>
    inpl = vector<int>(k);
    lixt = vector<pair<int, int>>(k);
    for (int i = 0; i < n; i++)
    {
        int inp;
        cin >> inp;
        ar.push_back(inp-1);
        inp--;
        inpl[inp]++;
    }
    for (int i = 0; i < k; i++)
    {
        lixt[i].first = inpl[i];
        lixt[i].second = i;
    }
    sort(lixt.begin(), lixt.end(), greater<pair<int, int>>());
    switch (g)
    {
        case 3:  
        {
            cout << n / 2 << " " << n - n / 2 - 1 << "\n";
            for (int i = 0; i < n / 2; i++)
            {
                cout << i + 1 << " ";
            }
            cout << "\n" << n / 2 + 1 << "\n";
            for (int i = n / 2 + 1; i < n; i++)
            {
                cout << i + 1 << " ";
            }
            break;

        }
        case 2:
        {
            cout << n / 2 << " " << n - n / 2 - 1 << "\n";
            vector<int> top = vector<int>(n / 2);
            vector<int> bottom = vector<int>(n - n / 2 - 1);
            for (int i = 0; i < top.size(); i += 2)
            {
                top[i] = lixt[0].second;
            }
            int tit = 0;
            for (int i = 1; i < top.size(); i += 2)
            {
                while (ar[tit] == lixt[0].second)
                {
                    tit++;
                }
                top[i] = ar[tit];
                tit++;
            }
            int cent;
            while (ar[tit] == lixt[0].second)
            {
                tit++;
            }
            cent = ar[tit] + 1;
            tit++;
            for (int i = 0; i < bottom.size(); i += 2)
            {
                bottom[i] = lixt[0].second;
            }
            for (int i = 1; i < bottom.size(); i += 2)
            {
                while (ar[tit] == lixt[0].second)
                {
                    tit++;
                }
                bottom[i] = ar[tit];
                tit++;
            }
            for (int i = 0; i < top.size(); i++)
            {
                cout << top[i] + 1 << " ";
            }
            cout << "\n" << cent << "\n";
            for (int i = 0; i < bottom.size(); i++)
            {
                cout << bottom[i] + 1 << " ";
            }

            break;
        }

        case 4:
        {
            M45();
            break;
        }
        case 5:
        {
            M45();
            break;
        }

        default:
            break;

    }
}