#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <set>

using namespace std;

vector<vector<int>> ways;
vector<vector<int>> comp;
vector<int> myid;

int main()
{
    int n, q, g;
    cin >> n >> q >> g;
    ways = vector<vector<int>>(n);
    comp = vector<vector<int>>(n);
    for (int i = 0; i < n; i++)
    {
        myid.push_back(i);
        comp[i].push_back(i);
    }

    for (int i = 0; i < q; i++)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int vi, ki;
            cin >> vi >> ki;
            vi--;
            sort(comp[myid[vi]].begin(), comp[myid[vi]].end());
            if (comp[myid[vi]].size() > ki-1)
            {
                cout << comp[myid[vi]][ki-1]+1 << "\n";
            }
            else cout << -1 << "\n";
        }
        if (t == 2)
        {
            int ai, bi;
            cin >> ai >> bi;
            ai--;
            bi--;
            if (myid[ai] != myid[bi]) 
            {
                int inid = myid[bi];
                for (int i = 0; i < comp[inid].size(); i++)
                {
                    int ind = comp[inid][i];
                    myid[ind] = myid[ai];
                    comp[myid[ai]].push_back(ind);
                }
            }
        }
    }
}
