#include<bits/stdc++.h>
using namespace std;

#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

template<typename TYPE,typename COMP>
using ordered_set=tree<
TYPE,
null_type,
COMP,
rb_tree_tag,
tree_order_statistics_node_update>;


struct dsu123{
int NMAX;
vector<ordered_set<int,less<int>>>num;
vector<int>lr,sz;

void init(int n){
    num.resize(n+1);
    lr.resize(n+1);
    sz.resize(n+1);
    for(int i=1;i<=n;i++)sz[i]=1,lr[i]=i,num[i].clear(),num[i].insert(i);
}
int get(int v){
    if(lr[v]==v)return v;
    else return lr[v]=get(lr[v]);
}
void unite(int u,int v){
    u=get(u);
    v=get(v);
    if(u==v)return;
    if(sz[u]>sz[v])swap(u,v);
    sz[v]+=sz[u];
    lr[u]=v;
    for(auto e:num[u])num[v].insert(e);
    num[u].clear();
}
};
void solve123(int n,int q){
    dsu123 cur;
    cur.init(n);
    dsu123 dsut[q+2];
    dsut[0]=cur;
    for(int i=0;i<q;i++){
        int t;
        cin>>t;
        if(t==1){
            int v,k;
            cin>>v>>k;
            if(cur.sz[cur.get(v)]<k)cout<<"-1\n";
            else cout<<*cur.num[cur.get(v)].find_by_order(k-1)<<"\n";
        }else if(t==2){
            int u,v;
            cin>>u>>v;
            cur.unite(u,v);
        }else{
            int x;
            cin>>x;
            cur=dsut[x];
        }
        dsut[i+1]=cur;
    }
}

struct dsu4{
int NMAX;
vector<int>left,right;
vector<int>lr,sz;

void init(int n){
    left.resize(n+1);
    right.resize(n+1);
    lr.resize(n+1);
    sz.resize(n+1);
    for(int i=1;i<=n;i++)sz[i]=1,lr[i]=i,left[i]=i,right[i]=i;
}
int get(int v){
    if(lr[v]==v)return v;
    else return lr[v]=get(lr[v]);
}
void unite(int u,int v){
    u=get(u);
    v=get(v);
    if(u==v)return;
    if(sz[u]>sz[v])swap(u,v);
    sz[v]+=sz[u];
    lr[u]=v;
    left[v]=min(left[u],left[v]);
    right[v]=max(right[u],right[v]);
}
};

void solve4(int n,int q){
    dsu4 cur;
    cur.init(n);
    for(int i=0;i<q;i++){
        int t;
        cin>>t;
        if(t==1){
            int v,k;
            cin>>v>>k;
            if(cur.sz[cur.get(v)]<k)cout<<"-1\n";
            cout<<cur.left[cur.get(v)]+k-1<<"\n";
        }else if(t==2){
            int u,v;
            cin>>u>>v;
            cur.unite(u,v);
        }else{
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n,q,g;
    cin>>n>>q>>g;
    if(g<=3)solve123(n,q);
    else if(g<=4)solve4(n,q);
}