#define _CRT_SECURE_NO_WARNINGS//MSVC compiler
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <cstdio>//yes, cstdio fan
#include <algorithm> 
#include <cassert> 
//#include <iostream> 
using namespace std;
template<typename T> using linear_stack = std::stack<T, std::vector<T>>;
//copy(vec.begin(), vec.end(), ostream_iterator<int>{cerr, " "});//simple IO
using ull = unsigned long long;
struct Node {
    unsigned cost = 0;
    bool is_white = true;
    vector<pair<unsigned, unsigned>> child;
};
vector<Node> gr;
ull g_cost = 0;
void off_vert(unsigned i) {
    for(auto [j, c] : gr[i].child) if(gr[j].cost) gr[j].cost-=c;
    gr[i].cost = 0;
    gr[i].is_white = false;
}
vector<pair<unsigned, ull>> res;
int main(void) {
    unsigned n, m, g;
    scanf("%u%u%u", &n, &m, &g);
    gr.resize(n);
    res.reserve(n+1);
    for(unsigned i = 1, u1, u2, c; i < n; i++) scanf("%u%u%u", &u1, &u2, &c), u1--, u2--, g_cost+=c, 
        gr[u1].child.push_back({u2, c}), gr[u2].child.push_back({u1, c}),
        gr[u1].cost+=c, gr[u2].cost+=c;
    res.push_back({0, g_cost});
    unsigned max_i = 0; unsigned max_c = 0;
    unsigned ci = 1;
    while(g_cost) {
        max_c = 0;
        max_i = 0;
        for(unsigned i = 0; i < n; i++) {
            auto c = gr[i].cost;
            if(c > max_c) {
                max_c = c;
                max_i = i;
            }
        }
        //if(g_cost < max_c)printf("error");
        g_cost -= max_c;
        res.push_back({ci++, g_cost});
        off_vert(max_i);
    }
    for(unsigned i = 0, j, k; i < m; i++) {
        scanf("%u", &k);
        for(j = 0; j < res.size(); j++) if(res[j].second <= k) break;
        printf("%u ", res[j].first);
        if(j == res.size()) assert(false);
    }
}