#include <bits/stdc++.h>
using namespace std;

long long n, m, g;
int graph[3000][3000];
bool used[3000];
int flag;
pair<int, int> queue_zap[3000];

void clear_used()
{
    for(int i = 1; i <= n; i++)
        used[i] = false;
}
void DFS(int st)
{
    used[st]=true;
    for (int i = 1; i <= n; i++)
        if ((graph[st][i] != 0) && (!used[i]))
            DFS(i);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> g;

    int zap, a, b, xi;
    for(int i = 0; i < m; i++)
    {
        cin >> zap;
        if(zap == 3)
        {
            cin >> xi;
            while(xi < i)
            {
                a = queue_zap[xi].first;
                b = queue_zap[xi].second;
                graph[a][b] = 0;
                graph[b][a] = 0;
                xi++;
            }
        }
        else
        {
            cin >> a >> b;
            if(zap == 2)
            {
                graph[a][b] = 13;
                graph[b][a] = 13;
                queue_zap[i] = make_pair(a, b);
            }
            else
            {
                clear_used();
                DFS(a);
                int i;
                for(i = 1; i <= n && b != 0; i++)
                {
                    if(used[i]) b--;
                }
                if(b != 0) cout << -1 <<"\n";
                else cout << i - 1<< "\n";
            }

        }


    }

}
