#include <iostream>
#include <vector>
#include <queue>

const int N = 2e5;

using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k, ng, mni = 0, nv = 0, col[N]{};
    cin >> n >> k >> ng;
    for(int i = 0, hp; i < n; ++i){
        cin >> hp; --hp;
        ++col[hp];
    }
    for(int i = 0; i < k; ++i)
        if(col[i] < col[nv])
            nv = i;
    if((col[nv] - 1) << 1 > n){
        cout << -1;
        return 0;
    }
    for(int i = 0; i < k; ++i)
        if(col[i] << 1 > n + 1){
            cout << -1;
            return 0;
        }
    if(k == 2 && (n % 2 == 0 || n == 5)){
        cout << -1;
        return 0;
    }
    vector<int> top, bottom;
    priority_queue<pair<int, int>> q;
    for(int i = 0; i < k; ++i)
        if(i != nv)
            q.push({col[i], i});
    int pr = nv;
    pair<int, int> cr, prp = {0, -1};
    --col[nv];
    //top setup
    cr = q.top();
    q.pop();
    top.push_back(cr.second);
    pr = cr.second;
    if(prp.first != 0)
        q.push(prp);
    --cr.first;
    prp = cr;
    if(col[nv]){
        --col[nv];
        top.push_back(nv);
        q.push(prp);
        pr = nv;
        prp.first = 0;
    }
    cr = q.top();
    q.pop();
    top.push_back(cr.second);
    pr = cr.second;
    if(prp.first != 0)
        q.push(prp);
    --cr.first;
    prp = cr;
    //end
    if(prp.first != 0)
        q.push(prp),
        prp.first = 0;
    while(!q.empty()){
        cr = q.top();
        q.pop();
        bottom.push_back(cr.second);
        --cr.first;
        pr = cr.second;
        if(prp.first != 0)
            q.push(prp);
        prp = cr;
        if(col[nv]){
            --col[nv];
            bottom.push_back(nv);
            q.push(prp);
            pr = nv;
            prp.first = 0;
        }
    }
    if(bottom[bottom.size() - 1] == nv){
        cout << -1;
        return 0;
    }
    cout << top.size() << ' ' << bottom.size() << '\n';
    for(int i = 0; i < top.size(); ++i)
        cout << top[i] + 1 << ' ';
    cout << '\n' << nv + 1 << '\n';
    for(int i = 0; i < bottom.size(); ++i)
        cout << bottom[i] + 1 << ' ';
    //*/
}
