//#pragma GGC optimize("O3,unroll-all-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
constexpr ll N = 2e5+7;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> sset;
struct segment_tree{
private:
    vector<pair<int,ll>> sgt_mx;
    vector<ll> a;
    int n;
    void build(int v,int l,int r){
        if(l == r) sgt_mx[v].second = l;
        else{
            build(v<<1,l,(l+r)>>1);
            build(v<<1|1,((l+r)>>1)+1,r);
            sgt_mx[v] = max(sgt_mx[v<<1],sgt_mx[v<<1|1]);
        }
    }
    void update(int v,int l,int r,int t,ll val){
        if(t < l or t > r) return;
        if(l == r){
            sgt_mx[v].first += val;
            return;
        }
        update(v<<1,l,(l+r)>>1,t,val);
        update(v<<1|1,((l+r)>>1)+1,r,t,val);
        sgt_mx[v] = max(sgt_mx[v<<1],sgt_mx[v<<1|1]);
    }
    pair<int,ll> get_mx(int v,int l,int r,int tl,int tr){
        if(tl <= l and r <= tr) return sgt_mx[v];
        if(r < tl or tr < l) return {0,0};
        return max(get_mx(v<<1,l,(l+r)>>1,tl,tr),get_mx(v<<1|1,((l+r)>>1)+1,r,tl,tr));
    }

public:
    segment_tree(){
        n = 0;
    }
    segment_tree(int N){
        n = N;
        sgt_mx.resize(4*N);
        a.resize(N);
        build(1,0,n-1);
    }
    segment_tree(vector<ll> A){
        a = A;
        n = A.size();
        sgt_mx.resize(4*N);
        build(1,0,n-1);
    }
    void update(int t,ll val){
        update(1,0,n-1,t,val);
    }
    pair<int,ll> mx(int tl,int tr){
        return get_mx(1,0,n-1,tl,tr);
    }
};
vector<pair<int,int>> Q;
vector<pair<int,int>> g[N];
ll dp[207][207][2];
ll dpT[6][6][2];
int n;
void dfs(int v,int p=-1){
    if((g[v].size()==1 and p!=-1) or(g[v].size() == 0 and p == -1)){
        for (int i = 0; i <= n; ++i) {
            dp[v][i][0] = 0;
            dp[v][i][1] = 1e18;
            if(i) dp[v][i][1] = 0;
        }
        return;
    }
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if(to == p) continue;
        dfs(to,v);
    }
    for (int i = 1; i <= g[v].size(); ++i) {
        for (int j = 0; j <= n; ++j) {
            dpT[i][j][0] = 1e18+7;
            dpT[i][j][1] = 1e18+7;
        }
    }
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        int w = g[v][i].second;
        if(to == p){
            for (int j = 0; j <= n; ++j) {
                dpT[i+1][j][0] = dpT[i][j][0];
                dpT[i+1][j][1] = dpT[i][j][1];
            }
            continue;
        }
        for (int j = 0; j <= n; ++j) {
            ll mn = 1e18+7;
            ll mn1 = 1e18+7;
            for (int k = 0; k <= j; ++k) {
                mn = min(mn,dpT[i][j-k][0]+dp[to][k][0]+w);
                mn = min(mn,dpT[i][j-k][0]+dp[to][k][1]);
                mn1 = min(mn1,dpT[i][j-k][1]+dp[to][k][0]);
                mn1 = min(mn1,dpT[i][j-k][1]+dp[to][k][1]);
            }
            dpT[i+1][j][0] = mn;
            dpT[i+1][j][1] = mn1;
            if(j) dpT[i+1][j][0] = min(dpT[i+1][j-1][0],dpT[i+1][j][0]);
            if(j) dpT[i+1][j][1] = min(dpT[i+1][j-1][1],dpT[i+1][j][1]);
        }
    }
    int NT = g[v].size();
    for (int i = 0; i <= n; ++i) {
        dp[v][i][0] = dpT[NT][i][0];
        dp[v][i][1] = 1e18+7;
        if(i) dp[v][i][1] = dpT[NT][i-1][1];
    }
}
int ans[N];
inline void solve(){
    int m,G;
    ll S = 0;
    cin >> n >> m >> G;
    segment_tree sgt(n+1);
    if(G == 1 or G == 2 or G == 0){
        for (int i = 0; i < n-1; ++i) {
            int a,b,c;
            cin >> a >> b >> c;
            S+=c;
            g[a].push_back({b,c});
            g[b].push_back({a,c});
            sgt.update(a,c);
            sgt.update(b,c);
        }
        for (int i = 0; i < m; ++i) {
            int a;
            cin >> a;
            Q.push_back({a,i});
        }
        sort(Q.begin(),  Q.end());
        int cnt = 0;
        for (int i = Q.size()-1; i >= 0; --i) {
            while (S > Q[i].first){
                cnt++;
                pair<int,ll> T = sgt.mx(1,n);
                S-=T.first;
                int v = T.second;
                sgt.update(v,-T.first);
                for (int j = 0; j < g[v].size(); ++j) {
                    int to = g[v][j].first;
                    int w = g[v][j].second;
                    sgt.update(to,-w);
                }
            }
            ans[Q[i].second] = cnt;
        }
        for (int i = 0; i < m; ++i) {
            cout << ans[i] << " ";
        }
    }
    else if(G == 4){
        vector<pair<pair<int,int>,int>> E;
        for (int i = 0; i < n-1; ++i) {
            int a,b,c;
            cin >> a >> b >> c;
            E.push_back({{a-1,b-1},c});
        }
        cin >> m;
        int best = 10;
        for (int i = 0; i < (1<<n); ++i) {
            int S = 0;
            for (int j = 0; j < E.size(); ++j) {
                int a,b,c;
                a = E[j].first.first;
                b = E[j].first.second;
                c = E[j].second;
                if((i>>a)&1 or (i>>b)&1) continue;
                S+=c;
            }
            if(S <= m) best = min(best,__builtin_popcount(i));
        }
        cout << best << "\n";
    }
    else if(G == 3){
        vector<int> E;
        E.resize(n);
        for (int i = 0; i < n-1; ++i) {
            int a,b,c;
            cin >> a >> b >> c;
            E[max(a,b)-1]=c;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j <= n; ++j) {
                dp[i][j][1] = 1e18;
                dp[i][j][0] = (bool)(i)*1e18;
            }
        }
        for (int i = 1; i < n; ++i) {
            ll mn = 1e18;
            for (int j = 0; j <= n; ++j) {
                mn = min(mn,dp[i-1][j][0]+E[i]);
                mn = min(mn,dp[i-1][j][1]);
                dp[i][j][0] = mn;
            }
            mn = 1e18;
            for (int j = 1; j <= n; ++j) {
                mn = min(mn,dp[i-1][j-1][0]);
                mn = min(mn,dp[i-1][j-1][1]);
                dp[i][j][1] = mn;
            }
        }
        for (int i = 0; i <= n; ++i) {
            dp[n-1][i][0] = min(dp[n-1][i][0],dp[n-1][i][1]);
        }
        for (int i = 0; i < m; ++i) {
            int a;
            cin >> a;
            Q.push_back({a,i});
        }
        sort(Q.begin(),  Q.end());
        int cnt = 0;
        for (int i = Q.size()-1; i >= 0; --i) {
            while (dp[n-1][cnt][0]> Q[i].first){
                cnt++;
            }
            ans[Q[i].second] = cnt;
        }
        for (int i = 0; i < m; ++i) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
    else if(G == 5){
        for (int i = 0; i < n-1; ++i) {
            int a,b,c;
            cin >> a >> b >> c;
            g[a-1].push_back({b-1,c});
            g[b-1].push_back({a-1,c});
        }
        dfs(0);
        for (int i = 0; i <= n; ++i) {
            dp[0][i][0] = min(dp[0][i][0],dp[0][i][1]);
        }
        for (int i = 0; i < m; ++i) {
            int a;
            cin >> a;
            Q.push_back({a,i});
        }
        sort(Q.begin(),  Q.end());
        int cnt = 0;
        for (int i = Q.size()-1; i >= 0; --i) {
            while (dp[0][cnt][0]> Q[i].first){
                cnt++;
            }
            ans[Q[i].second] = cnt;
        }
        for (int i = 0; i < m; ++i) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
}
int main(){
    //ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--) solve();
}
/*
4 0
1 2 1
1 3 200000000
2 3 3
2 4 3
 */