//#pragma GGC optimize("O3,unroll-all-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
constexpr ll N = 2e5+7;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> sset;
struct dsu{
    vector<sset> S;
    vector<int> p;
    vector<int> sz;
    void init(int n){
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            sz[i] = 1;
            S[i].clear();
            S[i].insert(i+1);
        }
    }
    dsu(){

    }
    dsu(int n){
        S.resize(n);
        p.resize(n);
        sz.resize(n);
        init(n);
    }
    int pr(int v){
        if(p[v] == v) return v;
        return p[v] = pr(p[v]);
    }
    void un(int u,int v){
        u = pr(u);
        v = pr(v);
        if(u == v) return;
        if(sz[v] < sz[u]) swap(u,v);
        // u to v;
        p[u] = v;
        sz[v]+=sz[u];
        for (auto e:S[u]) {
            S[v].insert(e);
        }
    }
};
vector<pair<int,pair<int,int>>> Q;
inline void solve(){
    int n,m,G;
    cin >> n >> m >> G;
    dsu d(n);
    for (int i = 0; i < m; ++i) {
        int type,u,v,k,x;
        cin >> type;
        if(type == 1){
            cin >> v >> k;
            v = d.pr(v-1);
            if(d.S[v].size() < k) cout << "-1\n";
            else {
                cout << *(d.S[v].find_by_order(k-1)) << "\n";
                
            }
        }else
        if(type == 2){
            cin >> v >> u;
            Q.push_back({i+1,{v-1,u-1}});
            d.un(u-1,v-1);
        }else{
            cin >> x;
            while (Q.size() and Q.back().first > x) Q.pop_back();
            d.init(n);
            for (int j = 0; j < Q.size(); ++j) {
                d.un(Q[j].second.first,Q[j].second.second);
            }
        }
    }
}
int main(){
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--) solve();
}
