#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<vector<pair<int,int>>> graf;

void solve(int n, lli s)
{
    lli k;
    cin >> k;
    if (s <= k) {
        cout << 0 << " ";
    } 
    else {
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < graf[i].size(); j++) {
                if (s - graf[i][j].second <= k) {
                    cout << 1 << " ";
                    return;
                }
            }
        }
        cout << 2;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    lli n,m,g;
    cin >> n >> m >> g;
    graf.resize(n + 1);
    lli s = 0;
    for (int i = 0; i < n-1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        graf[a].push_back({ b, c });
        graf[b].push_back({ a,c });
        s += c;
    }
    while(m--) solve(n,s);
}

