#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, tt;
    cin >> n >> k >> tt;
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        ++mp[x];
    }
    set<pair<int, int>> s; // {cnt_i, i}
    for (auto [i, j] : mp) {
        s.insert({j, i});
    }

    if (k == 1) {
        cout << -1 << '\n';
        return 0;
    }
    if (k == 2) {
        vector<int> cnt(2);
        for (auto [i, j] : mp) {
            cnt[i - 1] = j;
        }
        int central;
        if (cnt[0] > cnt[1]) {
            central = 1;
            --cnt[1];
        } else {
            central = 0;
            --cnt[0];
        }
        vector<int> low;
        int prev = central;
        for (int i = 0; i < 3; ++i) {
            if (prev == 0) {
                low.push_back(1);
                if (!cnt[1]) {
                    cout << -1 << '\n';
                    return 0;
                }
                --cnt[1];
                prev = 1;
            } else {
                low.push_back(0);
                if (!cnt[0]) {
                    cout << -1 << '\n';
                    return 0;
                }
                --cnt[0];
                prev = 0;
            }
        }
        vector<int> up;
        prev = central;
        while (cnt[0] || cnt[1]) {
            if (prev == 0) {
                up.push_back(1);
                if (!cnt[1]) {
                    cout << -1 << '\n';
                    return 0;
                }
                --cnt[1];
                prev = 1;
            } else {
                up.push_back(0);
                if (!cnt[0]) {
                    cout << -1 << '\n';
                    return 0;
                }
                --cnt[0];
                prev = 0;
            }
        }
        if (up.back() == central) {
            cout << -1 << '\n';
            return 0;
        }
        cout << up.size() << ' ' << low.size() << '\n';
        for (auto i : up) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
        cout << central + 1 << '\n';
        for (auto i : low) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
        return 0;
    }

    auto [cnt_c, central] = *s.begin();
    --mp[central];
    s.erase(s.begin());
    if (cnt_c - 1 > 0) {
        s.insert({cnt_c - 1, central});
    }

    vector<int> up;
    auto it = s.end();
    --it;
    auto [cnt, ind] = *it;
    up.push_back(ind);
    --mp[ind];
    s.erase(it);
    if (cnt - 1 > 0) {
        s.insert({cnt - 1, ind});
    }
    int prev = ind;
    if (mp[central]) {
        up.push_back(central);
        s.erase({mp[central], central});
        --mp[central];
        if (mp[central]) {
            s.insert({mp[central], central});
        }

        it = s.end();
        --it;
        auto [cnt, ind] = *it;
        up.push_back(ind);
        --mp[ind];
        s.erase(it);
        if (cnt - 1 > 0) {
            s.insert({cnt - 1, ind});
        }
    } else {
        it = s.end();
        --it;
        if (it->second == prev) {
            if (it == s.begin()) {
                cout << -1 << '\n';
                return 0;
            }
            --it;
        }
        auto [cnt, ind] = *it;
        up.push_back(ind);
        --mp[ind];
        s.erase(it);
        if (cnt - 1 > 0) {
            s.insert({cnt - 1, ind});
        }
    }
    vector<int> low;
    prev = central;
    while (!s.empty()) {
        if (prev != central && mp[central]) {
            s.erase({mp[central], central});
            --mp[central];
            if (mp[central]) {
                s.insert({mp[central], central});
            }
            low.push_back(central);
            prev = central;
        } else {
            it = s.end();
            --it;
            if (it->second == prev) {
                if (it == s.begin()) {
                    cout << -1 << '\n';
                    return 0;
                }
                --it;
            }
            auto [cnt, ind] = *it;
            low.push_back(ind);
            --mp[ind];
            s.erase(it);
            if (cnt - 1 > 0) {
                s.insert({cnt - 1, ind});
            }
            prev = ind;
        }
    }
    cout << up.size() << ' ' << low.size() << '\n';
    for (auto i : up) {
        cout << i << ' ';
    }
    cout << '\n';
    cout << central << '\n';
    for (auto i : low) {
        cout << i << ' ';
    }
    cout << '\n';
    return 0;
}
