#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e12;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, tt;
    cin >> n >> m >> tt;
    vector<vector<pair<int, int>>> g(n);
    long long sum = 0;
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        mp[{u, v}] = w;
        mp[{v, u}] = w;
        sum += w;
    }
    if (n == 1) {
        while (m--) {
            int k;
            cin >> k;
            cout << 0 << ' ';
        }
        return 0;
    }
    if (tt == 4) {
        while (m--) {
            int k;
            cin >> k;
            int res = n;
            for (int mask = 0; mask < (1 << n); ++mask) {
                int cnt = 0;
                long long sc = 0;
                for (int i = 0; i < n; ++i) {
                    if ((mask >> i) & 1) {
                        for (auto[j, w] : g[i]) {
                            if ((mask >> j) & 1) {
                                sc += w;
                            }
                        }
                    } else {
                        ++cnt;
                    }
                }
                if (sc / 2 <= k) {
                    res = min(res, cnt);
                }
            }
            cout << res << '\n';
        }
        return 0;
    }
    if (tt == 1) {
        while (m--) {
            int k;
            cin >> k;
            if (sum <= k) {
                cout << 0 << ' ';
            } else {
                cout << 1 << ' ';
            }
        }
        return 0;
    }
    if (tt == 2) {
        while (m--) {
            int k;
            cin >> k;
            if (sum <= k) {
                cout << 0 << ' ';
            } else {
                bool flag = false;
                for (int i = 0; i < n; ++i) {
                    long long currSum = sum;
                    for (auto [j, w] : g[i]) {
                        currSum -= w;
                    }
                    if (currSum <= k) {
                        cout << 1 << ' ';
                        flag = true;
                        break;
                    }
                }
                if (!flag) {
                    cout << 2 << ' ';
                }
            }
        }
        return 0;
    }
    if (tt == 3) {
        int root;
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 1) {
                root = i;
            }
        }
        int p = -1, curr = root;
        vector<int> v;
        for (int _i = 0; _i < n; ++_i) {
            v.push_back(curr);
            for (auto [j, w] : g[curr]) {
                if (j == p) {
                    continue;
                }
                curr = j;
                break;
            }

            p = curr;
        }
        vector<vector<vector<long long>>> dp(n, vector<vector<long long>>(n + 1, vector<long long>(2, INF)));
        dp[0][0][0] = 0;
        dp[0][1][1] = 0;
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j <= n; ++j) {
                dp[i][j][0] = min(dp[i][j][0], dp[i - 1][j][0] + mp[{v[i - 1], v[i]}]);
                dp[i][j][0] = min(dp[i][j][0], dp[i - 1][j][1]);
                if (j - 1 >= 0) {
                    dp[i][j][1] = min(dp[i][j][1], dp[i - 1][j - 1][0]);
                    dp[i][j][1] = min(dp[i][j][1], dp[i - 1][j - 1][1]);
                }
            }
        }
        while (m--) {
            long long k;
            cin >> k;
            int i = 0;
            while (dp.back()[i][0] > k) {
                ++i;
            }
            cout << i << ' ';
        }
        return 0;
    }
    return 0;
}
