import java.util.*;

public class Main {

    static class Pop {
        public int color;
        public int cnt;

        public Pop(int color, int cnt) {
            this.color = color;
            this.cnt = cnt;
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        int g = sc.nextInt();
        int[] arr = new int[n];
        //int[] count = new int[k];
        Random random = new Random();
        List<Pop> count = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            arr[i] = sc.nextInt();
            //arr[i] = random.nextInt(k) + 1;
            boolean b = false;
            for (int j = 0; j < count.size(); j++) {
                if (count.get(j).color == arr[i]) {
                    count.get(j).cnt++;
                    b = true;
                    break;
                }
            }
            if (!b) {
                count.add(new Pop(arr[i], 1));
            }
        }
        int min = Integer.MAX_VALUE;
        int min_color = 0;
        for (int i = 0; i < count.size(); i++) {
            Pop pop = count.get(i);
            if (pop.cnt > 0 && min > pop.cnt) {
                min = pop.cnt;
                min_color = pop.color;
            }
        }


        /*System.out.println(Arrays.toString(arr));
        System.out.println();
        for (Pop p: count) {
            System.out.println(p.color + " - " + p.cnt);
        }
        System.out.println();
        System.out.println(min_color);*/
        
        //prepare array
        int[] new_arr = new int[n+2];
        new_arr[0] = min_color;
        count.get(min_color-1).cnt--;
        new_arr[new_arr.length - 1] = min_color;
        boolean isCenterLightPassed = false;
        int cntCenterLightPassed = 0;
        int flag_i = 0;
        for (int i = 0; i < new_arr.length - 1; i++) {
            if (new_arr[i] == 0) {
                int number = 0;
                Collections.sort(count, (o1, o2) -> {
                    if (o1.cnt > o2.cnt) return -1;
                    if (o1.cnt < o2.cnt) return 1;
                    return 0;
                });
                for (int j = 0; j < count.size(); j++) {
                    Pop p = count.get(j);
                    if (p.cnt > 0 && p.color != new_arr[i-1] && p.color != new_arr[i+1]) {
                        number = p.color;
                        p.cnt--;
                        break;
                    }
                }
                new_arr[i] = number;
                cntCenterLightPassed++;
                if (!isCenterLightPassed && cntCenterLightPassed >= 2) {
                    if (min_color != number) {
                        isCenterLightPassed = true;
                        new_arr[i+1] = min_color;
                        i++;
                        flag_i = i;
                    }
                }
            }
        }
        /*System.out.println();
        System.out.println(Arrays.toString(new_arr));
        System.out.println(flag_i);
        System.out.println();*/
        //get answer
        String s1 = "" + (flag_i - 1) + " " + (n - flag_i);
        String s2 = "";
        String s3 = "" + new_arr[flag_i];
        String s4 = "";
        String s = "";
        for (int i = 1; i < new_arr.length - 1; i++) {
            if (i < flag_i) s2 += new_arr[i] + " ";
            else if (i > flag_i) s4 += new_arr[i] + " ";

            if (new_arr[i] == 0) {
                System.out.println("-1");
                return;
            }
        }
        System.out.println(s1);
        System.out.println(s2);
        System.out.println(s3);
        System.out.println(s4);
    }
}
