#include <cstdio>
#include <set>
#include <cassert>
#include <algorithm>

const int N = 200000;
int n, k, G, c[N];
std::set<std::pair<int, int> > st;

void rm(int x) {
	st.erase(std::make_pair(c[x], x));
	--c[x];
	if (c[x]) st.insert(std::make_pair(c[x], x));
}

int main() {
	scanf("%d%d%d", &n, &k, &G);
	for (int i = 0; i < n; ++i) {
		int x;
		scanf("%d", &x);
		--x;
		++c[x];
	}
	for (int i = 0; i < N; ++i) if (c[i]) st.insert(std::make_pair(c[i], i));
	if (st.size() == 1 || st.size() == 2 && (st.begin()->first + 1 != next(st.begin())->first || n == 5) || prev(st.end())->first * 2 - 1 > n) {
		printf("-1\n");
	} else {
		int to = n == 5 ? 2 : 3, cr = st.begin()->second;
		rm(cr);
		std::vector<int> up, down;
		int pr = cr, next = -1;
		for (int i = 0; i < to; ++i) {
			if (i == to - 1) next = cr;
			int cur = prev(st.end())->second;
			if (cur == pr || cur == next) {
				assert(st.size() > 1);
				cur = prev(prev(st.end()))->second;
				if (cur == next || cur == pr) {
					assert(st.size() > 2);
					cur = prev(prev(prev(st.end())))->second;
				}
			}
			rm(cur);
			up.push_back(cur);
			pr = cur;
		}
		pr = cr;
		next = -1;
		while (!st.empty()) {
			if (st.size() == 1) next = cr;
			int cur = prev(st.end())->second;
			if (cur == pr || cur == next) {
				assert(st.size() > 1);
				cur = prev(prev(st.end()))->second;
				if (cur == next || cur == pr) {
					assert(st.size() > 2);
					cur = prev(prev(prev(st.end())))->second;
				}
			}
			rm(cur);
			down.push_back(cur);
			pr = cur;
		}
		for (int i = 1; i < (int)up.size(); ++i) assert(up[i] != up[i - 1]);
		for (int i = 1; i < (int)down.size(); ++i) assert(down[i] != down[i - 1]);
		//assert(up.front() != cr);
		//assert(up.back() != cr);
		//assert(down.front() != cr);
		//assert(down.back() != cr);
		printf("%d %d\n", (int)up.size(), (int)down.size());
		for (int i = 0; i < (int)up.size(); ++i) printf("%d ", up[i] + 1);
		printf("\n%d\n", cr + 1);
		for (int i = 0; i < (int)down.size(); ++i) printf("%d ", down[i] + 1);
		printf("\n");
	}
	return 0;
}
