#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <cstdio>
#include <algorithm>
#include <vector>

const int N = 500005;
int n, m, G, type[N], x[N], y[N], top[N], size[N], ans[N];
std::vector<int> g[N];

int find(int v) {
	while (top[v] != -1) v = top[v];
	return v;
}

void dfs(int v) {
	if (type[v] == 1) {
		int need = find(x[v]);
		std::vector<int> res;
		for (int i = 0; i < n; ++i) if (find(i) == need) res.push_back(i);
		if (res.size() <= y[v]) ans[v] = -1;
		else {
			std::nth_element(res.begin(), res.begin() + y[v], res.end());
			ans[v] = res[y[v]] + 1;
		}
	} else if (type[v] == 2) {
		x[v] = find(x[v]);
		y[v] = find(y[v]);
		if (x[v] != y[v]) {
			if (size[x[v]] < size[y[v]]) std::swap(x[v], y[v]);
			size[x[v]] += size[y[v]];
			top[y[v]] = x[v];
		}
	}
	for (int i = 0; i < (int)g[v].size(); ++i) dfs(g[v][i]);
	if (type[v] == 2 && x[v] != y[v]) {
		size[x[v]] -= size[y[v]];
		top[y[v]] = -1;
	}
}

int main() {
	scanf("%d%d%d", &n, &m, &G);
	for (int i = 0; i < n; ++i) top[i] = -1;
	for (int i = 1; i <= m; ++i) {
		scanf("%d", type + i);
		if (type[i] == 1) {
			scanf("%d%d", x + i, y + i);
			--x[i];
			--y[i];
			g[i - 1].push_back(i);
		} else if (type[i] == 2) {
			scanf("%d%d", x + i, y + i);
			--x[i];
			--y[i];
			g[i - 1].push_back(i);
		} else {
			scanf("%d", x + i);
			g[x[i]].push_back(i);
		}
	}
	dfs(0);
	for (int i = 1; i <= m; ++i) if (type[i] == 1) printf("%d\n", ans[i]);
	return 0;
}
