#include <bits/stdc++.h>
#define pb push_back
using namespace std;
int p[500005];
int sz[500005];

int ffind(int v) {
    if(p[v] == v) {
        return v;
    }
    int r = ffind(p[v]);
    p[v] = r;
    return r;
}

void join(int u, int v) {
    u = ffind(u);
    v = ffind(v);
    if (u == v) {
        return;
    }
    if (sz[u] >= sz[v]) {
        p[v] = u;
        sz[u] += sz[v];
    }
    else {
        p[u] = v;
        sz[v] += sz[u];
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    for (int i = 1; i <= n; i++) {
        p[i] = i;
        sz[i] = 1;
    }
    if (g == 1) {
        while (q) {
            q--;
            int c, a, b;
            cin >> c >> a >> b;
            if (b == 1) {
                cout << a;
            }
            else {
                cout << -1;
            }
            cout << "\n";
        }
    }
    for (int p = 0; p < q; p++) {
        int c, a, b;
        cin >> c;
        if (c == 2) {
            cin >> a >> b;
            join(a, b);
        }
        if (c == 1) {
            cin >> a >> b;
            vector<int> gr;
            for (int i = 1; i <= n; i++) {
                if (ffind(i) == ffind(a)) {
                    gr.pb(i);
                }
            }
            if (gr.size() < b) {
                cout << -1 << "\n";
            }
            else {
                sort(gr.begin(), gr.end());
                cout << gr[b - 1] << "\n";
            }
        }
    }
    return 0;
}
