#include <bits/stdc++.h>

using namespace std;

void solve()
{
    long long n, k, g;
    cin >> n >> k >> g;

    long long lights[n];
    map<int, int> mp;

    for (int i = 0; i < n; i++)
    {
        cin >> lights[i];
        mp[lights[i] - 1]++;
    }

    vector<pair<int, int> > vqueue;
    int vqueue_index = 0;

    map<int, int> visited;

    for (int i = 0; i < n; i++)
    {
        int current = lights[i] - 1;

        if (mp[current] > 0 && visited[current] != 1)
        {
            vqueue.push_back(make_pair(mp[current], current));
        }

        visited[current] = 1;
    }

    pair<int, int> previous;
    previous = make_pair(-1, -1);
    vector<int> res(n);

    while (true)
    {
        if(vqueue_index >= vqueue.size())
            break;

        pair<int, int> k = vqueue[vqueue_index];
        res[vqueue_index] = k.second;

        if (previous.first > 0)
        {
            vqueue.push_back(previous);
        }

        vqueue_index++;
        k.first--;
        previous = k;
    }

    int centerInd = -1;
    bool exist = true;

    for (int i = 0; i < n; i++)
    {
        if (centerInd == -1 && res[i] != res[0] && res[i] != res[n - 1] && i >= 2 && i < n - 2)
        {
            centerInd = i;
        }

        if (res[i] == 0)
        {
            exist = false;
        }
    }

    if (exist && centerInd != -1)
    {
        cout << centerInd << " " << n - centerInd - 1 << endl;

        for (int i = 0; i < centerInd; i++)
        {
            cout << res[i] << " ";
        }

        cout << endl
             << res[centerInd] << endl;

        for (int i = centerInd + 1; i < n; i++)
        {
            cout << res[i] << " ";
        }

        cout << endl;
    }   else {
        cout << -1 << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
