#include <bits/stdc++.h>

using namespace std;

void solve()
{
    long long n, k, g;
    cin >> n >> k >> g;

    long long lights[n];
    long long colors[k];

    for(int i = 0; i < k; i++) {
        colors[i] = 0;
    }

    for (int i = 0; i < n; i++)
    {
        cin >> lights[i];
        colors[lights[i] - 1]++;
    }

    priority_queue<pair<int, int> > vqueue;
    int vqueue_index = 0;

    for (int i = 0; i < k; i++)
    {
        vqueue.push(make_pair(colors[i], i + 1));
    }

    pair<int, int> previous;
    previous = make_pair(-1, -1);
    vector<int> res(n);

    while (true)
    {
        if(!vqueue.size())
            break;

        pair<int, int> k = vqueue.top();
        vqueue.pop();
        res[vqueue_index] = k.second;

        if (previous.first > 0)
        {
            vqueue.push(previous);
        }

        vqueue_index++;
        k.first--;
        previous = k;
    }

    int centerInd = -1;
    bool exist = true;

    for (int i = 0; i < n; i++)
    {
        if (centerInd == -1 && res[i] != res[0] && res[i] != res[n - 1] && i >= 2 && i < n - 2)
        {
            centerInd = i;
        }

        if (res[i] == 0)
        {
            exist = false;
        }
    }

    if (exist && centerInd != -1)
    {
        cout << centerInd << " " << n - centerInd - 1 << endl;

        for (int i = 0; i < centerInd; i++)
        {
            cout << res[i] << " ";
        }

        cout << endl
             << res[centerInd] << endl;

        for (int i = n - 1; i >= centerInd + 1; i--)
        {
            cout << res[i] << " ";
        }

        cout << endl;
    }   else {
        cout << -1 << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}