#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, k, g;
	cin >> n >> k >> g;
    
    vector<int> colors(k);
    vector<int> lights;

    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        colors[t-1]++;
        lights.push_back(t);
    }

    if (n-*max_element(colors.begin(), colors.end()) < *max_element(colors.begin(), colors.end())-1) {
        cout << -1;
        return 0;
    }

    priority_queue<pair<int, int>> pq;
    pair<int, int> prev = {0, 0};
    for (int i = 0; i < k; i++) {
        pq.push(make_pair(colors[i], i+1));
    }
    vector<int> a;
    for (int i = 0; i < n; i++) {
        pair<int, int> curr = pq.top();
        pq.pop();
        if (prev.first) {
            pq.push(prev);
        }
        a.push_back(curr.second);
        curr.first--;
        prev = curr;
    }


    int l, r;
    if (n%2) {
        l = n/2;
        r = n/2;
    } else {
        l = n/2-1;
        r = n/2;
    }

    while (a[l] == a[0] || a[l] == a[a.size()-1]) {
        l+=1;
        r-=1;
    }


    cout << l << " " << r << endl;
    for (int i = 0; i < l; i++) {
        cout << a[i] << " ";
    }
    cout << endl << a[l] << endl;
    for (int i = l+1; i < n; i++) {
        cout << a[i] << " ";
    }

}
