#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#undef _GLIBCXX_DEBUG

#include<bits/stdc++.h>
using namespace std;


void solve(){
	int n, k, g;
	cin>>n>>k>>g;
	vector<int> amount(k, 0);
	vector<int> sorted(k);
	int maxCol=0;
	for(int i=0;i<n;i++){
		int a;
		cin>>a;
		a--;
		amount[a]++;
		if(amount[a]>amount[maxCol]){
			maxCol=a;
		}
		sorted[i]=i;
	}
	for(int i=0;i<k-1;i++){
		for(int j=i+1;j<k;j++){
			if(amount[sorted[i]]>amount[sorted[j]]){
				int temp = sorted[i];
				sorted[i]=sorted[j];
				sorted[j]=temp;
			}
		}
	}



	if(k==1){
		cout<<-1<<endl;
		return;
	}
	if(k==2){
		if(sorted[1]>sorted[0]+1||n<7){
			cout<<-1<<endl;
			return;
		}
		if(n%2==1){
			cout<<3<<" "<<n-4<<endl;
			cout<<sorted[1]+1<<" "<<sorted[0]+1<<" "<<sorted[1]+1<<endl;
			cout<<sorted[0]+1<<endl;
			for(int i=0;i<n-4;i++){
				cout<<sorted[(i+1)%2]+1<<" ";
			}cout<<endl;
		}else{
			cout<<-1<<endl;
			return;
		}
	}else{
		vector<int> ans(n, -1);
		int lastAval=0;
		for(int i=k-1;i>=0;i--){
			bool movedAval=false;
			int pos = lastAval;
			for(int j=pos; j<pos+amount[sorted[i]]*2-1;j+=2){
				if(j>=n){
					cout<<-1<<endl;
					return;
				}
				if(ans[j]!=-1){
					cout<<-1<<endl;
					return;
				}
				ans[j]=sorted[i];
				if(j<n){
					if(!movedAval && ans[j+1]==-1){
						movedAval=true;
						lastAval=j+1;
					}
				}
			}
			if(!movedAval){
				for(int j=lastAval+amount[sorted[i]]*2-1;j<n;j++){
					if(ans[j]==-1){
						lastAval=j;
						break;
					}
				}
			}
		}


		/*cout<<"------------\n";
		for(int i:ans){
			cout<<i+1<<" ";
		}cout<<endl;
		cout<<"------------\n";*/
		if(ans[0]==ans[n-1]){
			for(int i=2; i<(n+1)/2; i++){
				if(ans[i]!=ans[0]){
					cout<<i<<" "<<n-i-1<<endl;
					for(int j=0;j<i;j++){
						cout<<ans[j]+1<<" ";
					}cout<<endl;
					cout<<ans[i]+1<<endl;
					for(int j=i+1;j<n;j++){
						cout<<ans[j]+1<<" ";
					}cout<<endl;
					return;
				}
				if(ans[n-1-i]!=ans[0]){
					cout<<n-i-1<<" "<<i<<endl;
					for(int j=0;j<n-1-i;j++){
						cout<<ans[j]+1<<" ";
					}cout<<endl;
					cout<<ans[n-1-i]+1<<endl;
					for(int j=n-i;j<n;j++){
						cout<<ans[j]+1<<" ";
					}cout<<endl;
					return;
				}
			}
		}else{
			for(int k=0;k<n;k++){
				for(int i=2; i<n-2; i++){
					if(ans[(k+i)%n]!=ans[k]&&ans[(k+i)%n]!=ans[(k+1)%n]){
						cout<<i<<" "<<n-i-1<<endl;
						for(int j=0;j<i;j++){
							cout<<ans[(k+j)%n]+1<<" ";
						}cout<<endl;
						cout<<ans[(k+i)%n]+1<<endl;
						for(int j=i+1;j<n;j++){
							cout<<ans[(k+j)%n]+1<<" ";
						}cout<<endl;
						return;
					}
				}
			}
		}
	}

}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin>>t;
	while(t--){
		solve();
	}
}
