#include <queue>
#include <vector>
#include <map>
#include <iostream>

using namespace std;

vector<int> ans;

void vectSort(vector<int> vect, int n)
{
    map<int, int> freq;
    map<int, bool> vis;
    vector<int> result(n);

    for(int i = 0; i < n; ++i)
    {
        freq[vect[i]]++;
    }
     
    priority_queue<pair<int, int>> q;
     
    for(int i = 0; i < n ; ++i)
    {
        int value = vect[i];
        if (freq[value] > 0 && !vis[value])
        {
            q.push({freq[value], value});
        }
        vis[value] = true;
    }
     
    pair<int, int> prev = {-1, -1};
    int i = 0;
     
    while (q.size() != 0)
    {
        pair<int,int> k = q.top();
        q.pop();
        result[i] = k.second;
         
        if (prev.first > 0)
        {
            q.push(prev);
        }
         
        --k.first;
        prev = k;
        ++i;
    }
     
    for(auto x : result)
    {
        if (x == 0)
        {
            cout << -1 << "\n";
            return;
        }
    }
     
    ans = result;
}

int main()
{
    vector<int> v;
    int n, k, g, h, ind;
    cin >> n >> k >> g;
    for(int i = 0; i < n; ++i) {
        cin >> h;
        v.push_back(h);
    }
    vectSort(v, n);
    h = -1;
    for(int i = 2; i < ans.size() - 2; ++i) {
        if(ans[i] != ans[i - 1] && ans[i] != ans[i + 1] && ans[i] != ans[0] && ans[i] != ans[ans.size() - 1]) {
            h = ans[i];
            ind = i;
            break;
        }
    }

    if(h == -1) {
        cout << -1;
        return 0;
    }

    cout << ind << " " << ans.size() - ind -1 << "\n";

    for(int i = 0; i < ind; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n" << h << "\n";
    for(int i = ind + 1; i < ans.size(); ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}