#include <iostream>
#include <vector>
//#define DUMP
using namespace std;
bool has_lichtar(const vector<int>& a)
{
	for(int i = 0; i < a.size(); ++i)
	{
		if (a[i] > 0)
			return true;
	}
	return false;
}

int has_not_a1_and_a2(const vector<int>& a, int a1, int a2 = -1)
{
	int pos = -1;
	for(int i = 0; i < a.size(); ++i)
	{
		if (a[i] > 0 && i != a1 && i != a2)
		{
			pos = i;
			return pos;
		}
	}
	return pos;
}

int count_lichtar(const vector<int>& a)
{
	int count = 0;
	for(int i = 0; i < a.size(); ++i)
	{
		if (a[i] > 0)
		{
			count++;
		}
	}
	return count;
}

int get_not_zero(const vector<int>& a)
{
	for(int i = 0; i < a.size(); ++i)
	{
		if (a[i] > 0)
		{
			return i;
		}
	}
	return -1;
}

void failed()
{
	cout << -1 << endl; 
}

void dump(const vector<int>& a)
{
#ifdef  DUMP 
	cout << "dump: ";
	for(int i = 0; i < a.size(); ++i)
	{
		cout << a[i] << " ";
	}
	cout << endl;
#endif
}

int main()
{
	int n, k, g;
	int i, s;
	cin >> n >> k >> g;
	vector<int> a(k);
	for(i = 0; i < k; ++i)
	{
		a.push_back(0);
	}
	for(i = 0; i < n; ++i)
	{
		cin >> s;
		a[s - 1]++;
	}
#ifdef DUMP 
	for(i = 0; i < k; ++i)
	{
		cout << i + 1 << "-" << a[i]<< endl;
	}
#endif
	int mn = a[0], ci=0, pb1 = -1, pb2 = -1, ab1 = -1, ab2 = -1, ab3 = -1;
	int cross;
#ifdef DUMP 
	cout << "k=" << k << endl;
#endif
	if (k > 2)
	{
		for(i=1; i < k; ++i)
		{
			if (mn > a[i] && a[i] > 0)
			{
				mn = a[i];
				ci = i;
			}
		}
		cross = ci;
		a[ci] -= 1;
		for(i=0; i < k; ++i)
		{
#ifdef DUMP
			cout << "ci=" << ci << " i=" << i << " pb1="  << pb1 << endl;
#endif
			if (i!=ci && pb1 < 0 && a[i] > 0)
			{
				pb1 = i;
			}
			if (i!=ci && pb2 < 0 && i != pb1 && a[i] > 0)
			{
				pb2 = i;
			}
			if (pb1 > 0 && pb2 > 0)
			{
				break;
			}
		}
		ab1 = pb1;
		ab2 = pb2;
		a[pb1] -=1;
		a[pb2] -=1;
	}
	else
	{
		cross = (a[0] > a[1]) ? a[0] : a[1];
#ifdef DUMP
		cout << "corss=" << cross << endl;
#endif
		if (cross == 0)
		{
			cross = ab2 = 0;
			ab1 = ab3 = 1;
			a[0] -= 2;
			a[1] -= 2;
		}
		else
		{
			cross = ab2 = 1;
			ab1 = ab3 = 0;
			a[0] -= 2;
			a[1] -= 2;
		}
		
		if (a[0] < 0 || a[1] < 0)
		{
			failed();
			return 0;
		}
#ifdef DUMP
		cout << "corss=" << cross <<  " ab1=" << ab1 << " ab2=" << ab2 << " ab3=" << ab3 << endl;
#endif

	}
	int ca = cross, pos;
	std::vector<int> result;
	result.reserve(n);
	bool has_result = true;
	while (has_lichtar(a))
	{
		dump(a);
		pos = has_not_a1_and_a2(a, ca);
#ifdef DUMP 
		cout << "p=" << pos << endl;
#endif
		if (pos < 0)
		{
			has_result = false;
			break;
		}
		ca = pos;
		result.push_back(pos);
		a[pos] -= 1;
		if (count_lichtar(a) == 1)
		{
			int idx = get_not_zero(a);
			if (idx == cross)
			{
				failed();
				return 0;
			}
		}
	}
	if (has_result)
	{
		int bc = 0;
		if (ab1 != -1)
			bc++;
		if (ab2 != -1)
			bc++;
		if (ab3 != -1)
			bc++;
		cout << result.size() << " " << bc << endl;
		for(int i = 0; i < result.size(); ++i)
		{
			cout << result[i] + 1 << " ";
		}
		cout << endl;
		cout << cross + 1 << endl;
		if (ab1 != -1)
			cout << ab1 + 1 << " ";
		if (ab2 != -1)
			cout << ab2 + 1 << " ";
		if (ab3 != -1)
			cout << ab3 + 1 << " ";
		cout << endl;
	}
	else
	{
		failed();
		return 0;
	}
}
