#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;

#define pb push_back
#define fi first
#define se second

const int nmax=300012;

tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> st[nmax];
int pr[nmax]={0};

int fp(int v)
{
    if(pr[v]==0)
        return v;
    return pr[v]=fp(pr[v]);
}

int query(int v,int k)
{
    //cout << v << " v ";
    v=fp(v);
    if(k>st[v].size())
        return -1;
    return *st[v].find_by_order(k-1);
}

void unite(int u,int v)
{
    u=fp(u);
    v=fp(v);
    if(u==v)
        return ;
    if(st[u].size()<st[v].size())
        swap(st[u],st[v]);
    for(int i:st[v])
        st[u].insert(i);
    pr[v]=u;
    return ;
}

vector<array<int,3>> qr;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n,q,g,t,v,k,u;
    cin >> n >> q >> g;
    for(int i=1;i<=n;i++)
        st[i].insert(i);
    for(int i=0;i<q;i++)
    {
        cin >> t;
        if(t==3)
        {
            //qr.pb({1,0,0});
            cin >> t;
            for(int i=1;i<=n;i++)
            {
                st[i].clear();
                st[i].insert(i);
            }
            fill(pr,pr+n+2,0);
            for(int i=0;i<t;i++)
            {
                if(qr[i][0]==1)
                    continue;
                unite(qr[i][1],qr[i][2]);
            }
            continue;
        }
        if(t==1)
        {
            cin >> v >> k;
            qr.pb({1,v,k});
            cout << query(v,k) << "\n";
        }
        else
        {
            cin >> u >> v;
            qr.pb({2,u,v});
            unite(u,v);
        }
    }
    return 0;
}

/*
10 3 0
1 1 1 1 2 2 2 3 3 3
*/
