def solution(n, k, lamps):
  top = []
  middle = []
  bottom = []

  if n == k:
    top = [lamps.pop(), lamps.pop()]
    middle = [lamps.pop()]
    bottom = lamps
  elif k == 2:
    less_num = 1 if lamps.count(1) < lamps.count(2) else 2
    opposite_num = 1 if less_num == 2 else 2

    middle = [less_num]
    n -= 1
    top = [opposite_num, less_num, opposite_num]
    n -= 3
    bottom = [opposite_num, less_num, opposite_num]
    n -= 3

    while n > 0:
      bottom.append(less_num)
      bottom.append(opposite_num)
      n -= 2
    
  if not len(middle):
    print(-1)
  else:
    print(f"{len(top)} {len(bottom)}")
    print(" ".join(map(str, top)))
    print(middle[0])
    print(" ".join(map(str, bottom)))

n, k, g = map(int, input().split())
lamps = list(map(int, input().split()))

solution(n, k, lamps)