//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

#define int long long
#define fi first
#define se second

bool cmp(pair<int, int>& a, pair<int, int>& b)
{
	return a.first > b.first;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, k, g, c;
	cin >> n >> k >> g;
	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; ++i) a[i].second = i + 1;
	for (int i = 0; i < n; ++i)
	{
		cin >> c;
		--c;
		a[c].first++;
	}
	sort(a.begin(), a.end(), cmp);
	if (a[0].first > (n + 1) / 2)
	{
		cout << -1 << '\n';
		return 0;
	}
	if (n == 5 && a[0].first == 3)
	{
		cout << -1 << '\n';
		return 0;
	}
	/*if (!(n & 1) && a[0].first == a[1].first && a[0].first == n / 2)
	{
		cout << -1 << '\n';
		return 0;
	}*/
	if (n == 5)
	{
		int d = 0;
		int u = 0;
		int mid = -1;
		vector<int> up(2), down(2);
		for (int i = 0; i < k; ++i)
		{
			if (a[i].first > 0 && u < 2)
			{
				up[u] = a[i].second;
				++u;
				--a[i].fi;
			}
			if (a[i].first > 0 && d < 2)
			{
				down[d] = a[i].second;
				++d;
				--a[i].fi;
			}
			if (a[i].first > 0 && mid == -1)
			{
				mid = a[i].second;
				--a[i].fi;
			}
		}
		cout << 2 << " " << 2 << '\n';
		cout << up[0] << " " << up[1] << '\n';
		cout << mid << '\n';
		cout << down[0] << " " << down[1] << '\n';
		return 0;
	}
	vector<int> up(3);
	int mid;
	vector<int> down(n - 3);
	if (a[0].first == 1)
	{
		cout << 2 << " " << n - 3 << '\n';
		cout << 1 << " " << 2 << '\n';
		cout << 3 << '\n';
		for (int i = 4; i <= n; ++i) cout << i << " ";
		cout << '\n';
		return 0;
	}
	if (n == 6 && k == 3 && a[2].first == 2)
	{
		cout << 3 << " " << 2 << '\n';
		cout << 3 << " " << 1 << " " << 2 << '\n';
		cout << 1 << '\n';
		cout << 2 << " " << 3 << '\n';
		return 0;
	}
	int u, d, ge, x = 0;
	if (true)
	{
		up[0] = up[2] = a[0].second;
		a[0].first -= 2;
		up[1] = a[1].second;
		--a[1].first;
		u = 3;
		d = 0;
		ge = 0;
		x = 1;
	}
	else
	{
		mid = a[0].se;
		up[1] = a[0].second;
		a[0].first -= 2;
		u = 0;
		d = 1;
		ge = 1;
		down[n - 4] = a[0].second;
	}
	for (int i = 0; i < k; ++i)
	{
		while (a[i].first && ge < (n - 3))
		{
			down[d] = a[i].second;
			--a[i].first;
			++ge;
			d += 2;
			if (d >= n - 3) d -= n - 3;
			if (ge < (n - 3))
			{
				while (down[d])
				{
					d++;
					if (d >= n - 3) d -= n - 3;
				}
			}
		}
		while (a[i].fi)
		{
			up[u] = a[i].second;
			--a[i].first;
			u += 2;
		}
	}
	if (x) mid = down[n - 4];
	cout << 3 << " " << n - 4 << '\n';
	for (int i = 0; i < 3; ++i) cout << up[i] << " ";
	cout << '\n';
	cout << mid << '\n';
	for (int i = 0; i < n - 4; ++i) cout << down[i] << " ";
	cout << '\n';
	return 0;
}

/*

*/