#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <functional>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <stack>


using namespace std;

#define int long long

bool check(vector<int> v1, int v2, vector<int> v3){
    if(min(v1.size(),v3.size()) < 2){
        return 0;
    }
    for(int i = 1;i<v1.size();i++) if(v1[i] == v1[i-1]) return 0;
    for(int i = 1;i<v3.size();i++) if(v3[i] == v3[i-1]) return 0;
    if(v1[0] == v2 || v3[0] == v2 || v1.back() == v2 || v3.back() == v2){
        return 0;
    }
    return 1;
}

void solve(int n,int a, vector<int> vv){
    map<int,int> m;
    int maxi = 0;
    for(int x : vv){
        m[x]++;
        maxi = max(maxi,m[x]);
    }
    for(auto it: m){
        if(n%2 == 0 && it.second >= (n/2+1)){
            cout << -1 << endl;
            return;
        }
        if(it.second > (n/2+1)){
            cout << -1 << endl;
            return;
        }
    }
    vector<int> v;
    for(auto it:m){
        if(it.second != maxi){
            for(int i = 0;i<it.second;i++) v.push_back(it.first);
        }
    }
    for(auto it : m){
        if(it.second == maxi){
            for(int i = 0;i<it.second;i++) v.push_back(it.first);
        }
    }
    if(n == 5 && maxi == 3){
        cout << -1 << endl;
        return;
    }
    int l,r;
    l = 3;
    r = v.size()-1;
    vector<int> v1,v2,v3;
    v2.push_back(v[0]);
    v1.push_back(v[1]);
    v1.push_back(v[r]);
    v3.push_back(v[r-1]);
    v3.push_back(v[2]);
    r -= 2;
    while(l <= r){
        if(v[l] == v[r]){
            if(l == r){
                v1.push_back(v[l]);
                l++;
                break;
            }
            v1.push_back(v[l]);
            l++;
            v3.push_back(v[r]);
            r--;
            continue;
        }
        v1.push_back(v[r]);
        r--;
        v1.push_back(v[l]);
        l++;
    }
    if(v2.back() == v3.back()){
        v3.push_back(v1.back());
        v1.pop_back();
    }
    if(v2.back() == v3.back() || v1.back() == v2.back()){
        cout << -1 << endl;
        return;
    }
    while(v1.back() == v1[v1.size()-2]){
        for(int i = 0;i<v1.size();i++){
            if(v1[i] != v1.back() && v1[i+1] != v1.back()){
                v1.insert(v1.begin()+i, v1.back());
                v1.pop_back();
                break;
            }
        }
    }
    for(int i = 1;i<v1.size();i++){
        if(v1[i-1] == v1[i]){
            v1.push_back(v1[i]);
            v1.erase(v1.begin()+i);
        }
    }
    while(v3.back() == v3[v3.size()-2]){
        for(int i = 0;i<v3.size();i++){
            if(v3[i] != v3.back() && v3[i+1] != v3.back()){
                v3.insert(v3.begin()+i, v3.back());
                v3.pop_back();
                break;
            }
        }
    }
    if(v1[0] == v2[0] && v1.back() != v1[0]){
        v1.insert(v1.begin(),v1.back());
        v1.pop_back();
    }
    /*
    if(!check(v1,v2[0],v3)){
        for(auto it:v1) cout << it << " ";
        cout << endl;
        for(auto it:v2) cout << it << " ";
        cout << endl;
        for(auto it:v3) cout << it << " ";
        cout << endl;
        exit(0);
        
    }
     */
    cout << v1.size() << " " << v3.size() << endl;
    for(auto it:v1) cout << it << " ";
    cout << endl;
    for(auto it:v2) cout << it << " ";
    cout << endl;
    for(auto it:v3) cout << it << " ";
    cout << endl;
    
    
}


signed main(){
    srand(time(0));
    int n,a,t;
    cin >> n >> a >> t;
    vector<int> v(n);
    for(int i=0;i<n;i++) cin >> v[i];
    solve(n,a,v);

}
