#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int n, m, g;
vector<vector<pair<int, int> > > tree(3001);
vector<int> k(200'000);
ll sum=0;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n >> m >> g;
	map<pair<int, int>, int> edge;
	for(int i=0; i<n-1; i++){
        int u, v, c;
        cin >> u >> v >> c;
        tree[u].push_back({v, c});
        tree[v].push_back({u, c});
        edge[{u, v}]=c;
        edge[{v, u}]=c;
        sum+=c;
	}
	for(int i=0; i<m; i++){
        cin >> k[i];
	}

	if(g==1){
	    cout << (sum<=k[0]? 0 : 1);
	    return 0;
	}
	if(g==2){
        if(sum<=k[0]){
            cout << 0;
            return 0;
        }
        ll mn=LLONG_MAX;
        for(int v=1; v<=n; v++){
            ll cur_sum=sum;
            for(auto p: tree[v]){
                int u=p.fi;
                cur_sum-=edge[{v, u}];
            }
            mn=min(mn, cur_sum);
        }
        cout << (mn<=k[0]? 1 : 2);
        return 0;
	}
	if(g==3){
        set<pair<int, int>, greater<pair<int, int> > > v_by_c;
        for(int v=1; v<=n; v++){
            int cur_sum=0;
            for(auto p: tree[v]){
                cur_sum+=p.se;
            }
            v_by_c.insert({cur_sum, v});
        }
        map<pair<int, int>, bool> excl;

        vector<ll> val(n+1, 0);
        val[0]=sum;
        for(int i=1; i<=n; i++){
            pair<int, int> p=*v_by_c.begin();
            v_by_c.erase(p);
            int c=p.fi, v=p.se;
            sum-=c;
            val[i]=sum;
            for(auto x: tree[v]){
                int u=x.fi, w=x.se;
                if(!excl[{v, u}]){
                    excl[{v, u}]=1;
                    excl[{u, v}]=1;
                    for(auto &y: v_by_c){
                        if(y.se==u){
                            pair<int, int> yy=y;
                            v_by_c.erase(y);
                            v_by_c.insert({yy.fi-w, yy.se});
                            break;
                        }
                    }
                }
            }
        }

        for(int i=0; i<m; i++){
            int l= -1, r=n;
            while(r-l>1){
                int mid=(l+r)/2;
                if(val[mid]<=k[i]){
                    r=mid;
                }
                else{
                    l=mid;
                }
            }
            cout << r << ' ';
        }
        return 0;
	}
}
