#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int n, m, g;
vector<vector<pair<int, int> > > tree(3001);
vector<int> k(200'000);
ll sum=0;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n >> m >> g;
	map<pair<int, int>, int> edge;
	for(int i=0; i<n-1; i++){
        int u, v, c;
        cin >> u >> v >> c;
        tree[u].push_back({v, c});
        tree[v].push_back({u, c});
        edge[{u, v}]=c;
        edge[{v, u}]=c;
        sum+=c;
	}
	for(int i=0; i<m; i++){
        cin >> k[i];
	}

	if(g==1){
	    cout << (sum<=k[0]? 0 : 1);
	    return 0;
	}
	if(g==2){
        if(sum<=k[0]){
            cout << 0;
            return 0;
        }
        ll mn=LLONG_MAX;
        for(int v=1; v<=n; v++){
            ll cur_sum=sum;
            for(auto p: tree[v]){
                int u=p.fi;
                cur_sum-=edge[{v, u}];
            }
            mn=min(mn, cur_sum);
        }
        cout << (mn<=k[0]? 1 : 2);
        return 0;
	}
	if(g==3){
        if(n==1){
            for(int i=0; i<m; i++){
                cout << 0 << ' ';
            }
            return 0;
        }
        vector<ll> val(n+1, 0);
        val[0]=sum;

        vector<int> color(n+1, 0);

        for(int i=1; i<=n; i++){
            int mx=0, mx_node;
            for(int node=1; node<=n; node++){
                if(!color[node]){
                    int cur=0;
                    for(auto p: tree[node]){
                        int u=p.fi;
                        if(!color[u]){
                            cur+=p.se;
                        }
                    }
                    if(cur>mx){
                        mx=cur;
                        mx_node=node;
                    }
                }
            }
            color[mx_node]=1;
            sum-=mx;
            val[i]=sum;
        }

        for(int i=0; i<m; i++){
            int l= -1, r=n-1;
            while(r-l>1){
                int mid=(l+r)/2;
                if(val[mid]<=k[i]){
                    r=mid;
                }
                else{
                    l=mid;
                }
            }
            cout << r << ' ';
        }
        return 0;
	}

	if(g==4){
        int ans=n;
        for(int i=0; i<(1<<n); i++){
            vector<bool> color(n+1, 0);
            int cnt=0;
            for(int v=1; v<=n; v++){
                if(i & (1<<(v-1))){
                    color[v]=1;
                    cnt++;
                }
            }
            ll cur_sum=0;
            for(auto p: edge){
                int v=p.fi.fi, u=p.fi.se;
                if(!color[u] && !color[v]){
                    cur_sum+=p.se;
                }
            }
            cur_sum/=2;
            if(cur_sum<=k[0]){
                ans=min(ans, cnt);
            }
        }
        cout << ans;
        return 0;
	}
}