#include <bits/stdc++.h>

using namespace std;

class Graph
{
public:
    int v;
    typedef array<int,3> edge;
    vector <edge> edges;
    vector <int> weights;
    int power;
    Graph (int vin)
    {
        v=vin;
        power=0;
        for (int i=0; i<vin; i++) weights.push_back(0);
    }
    void add_edge(int a, int b, int w)
    {
        edges.push_back({a,b,w});
    }
    void weight ()
    {
        for (int i=0; i<v-1; i++)
        {
            edge e = edges[i];
            power+=e[2];
            weights[e[0]-1]+=e[2];
            weights[e[1]-1]+=e[2];
        }
    }
    int solve (int k)
    {
        int res=0;
        vector<int> we = weights;
        vector<edge> ed = edges;
        int total = power;
        while (total>k)
        {
            int maxVI = 0;
            for (int i=1; i<v; i++)
            {
                if (we[i]>we[maxVI]) maxVI=i;
                if (we[i]==we[maxVI])
                {
                    int weI=0, weM=0;
                    for (int i=0; i<ed.size(); i++)
                    {
                        if (ed[i][0]==weI || ed[i][1]==weI) weI+=ed[i][2];
                        if (ed[i][0]==weM || ed[i][1]==weM) weM+=ed[i][2];
                    }
                    if (weM>weI) i=weM;
                }
            }
            total-=we[maxVI];
            we[maxVI]=0;
            res++;
            int i=0;
            while(i<ed.size())
            {

                if (ed[i][0]-1==maxVI || ed[i][1]-1==maxVI)
                {
                    if (ed[i][0]-1==maxVI)
                    {
                        we[ed[i][1]-1]-=ed[i][2];
                    }
                    else
                    {
                        we[ed[i][0]-1]-=ed[i][2];
                    }
                    ed[i]={-1,-1,-1};
                }
                i++;
            }
        }
        return res;
    }
};

int main()
{
    ios_base::sync_with_stdio();
    ifstream in("input.txt");
    in.tie(0);
    cin.tie(0);
    cout.tie(0);
    int n,m,g,a,b,w,k;
    in>>n>>m>>g;
    Graph test(n);
    for (int i=0; i<n-1; i++)
    {
        in>>a>>b>>w;
        test.add_edge(a,b,w);
    }
    test.weight();
    while (in>>k)
    {
        cout<<test.solve(k)<<' ';
    }
    return 0;
}
