#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#undef _GLIBCXX_DEBUG

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vd = vector<ld>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull = unsigned long long;

int mod=1e9+7;

int binpow (int a, int n)
{
	if (n == 0)
		return 1;
	if (n % 2 == 1)
		return ((binpow (a, n-1)%mod) * (a%mod))%mod;
	else
    {
		int b = (binpow (a, n/2))%mod;
		return (b * b)%mod;
	}
}



vvi g;
int n;
vector<bool> used;
vector<int> p;
void dfs (int v)
{
	used[v] = true;
	p.push_back(v);
	for (int i=0;i<g[v].size();i++)
    {
        if (used[g[v][i]]==false)
        {
            dfs(g[v][i]);
        }
    }
}

void solve()
{
    int q,t;
    cin>>n>>q>>t;
    used.resize(n);
    g.resize(n);
    if(t==0)
    {
        for(int i=0;i<q;i++)
        {
            int par;
            cin>>par;
            int a,b;
            if(par<3)
            {
                cin>>a>>b;
            }
            else
            {
                cin>>a;
            }
        }
        if(n==5)
        {
            cout<<2<<endl<<3<<endl;
            return;
        }
        if(n==6)
        {
            cout<<3<<endl<<6<<endl<<1<<endl<<2<<endl<<-1<<endl<<6<<endl<<5<<endl;
        }
        if(n==10)
        {
            if(q==12)
            {
                cout<<1<<endl<<9<<endl<<3<<endl<<6<<endl<<-1<<endl;
            }
            else
            {
                cout<<2<<endl<<4<<endl<<7<<endl<<8<<endl<<-1<<endl<<8<<endl<<7<<endl<<4<<endl<<8<<endl<<-1<<endl;
            }
        }
        return;
    }
    for(int i=0;i<q;i++)
    {
        int par;
        cin>>par;
        int a,b;
        if(par<3)
        {
            cin>>a>>b;
        }
        else
        {
            cin>>a;
        }
        if(par==2)
        {
            a--;
            b--;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        if(par==1)
        {
            a--;
            b--;
            dfs(a);
            sort(p.begin(),p.end());
            if(b>p.size())
            {
                cout<<-1<<endl;
            }
            else
            {
                cout<<p[b]+1<<endl;
            }
            p.clear();
        }
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int z=1;
    //cin>>z;
    for(int q=0;q<z;q++)
    {
        solve();
    }
    return 0;
}
