#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>

using namespace std;

vector<vector<pair<int, int>>> ways;
vector<int> sums;

int main()
{
    int n, m, g, made = 0, allsum = 0;
    cin >> n >> m >> g;
    vector<int> xs = vector<int>(m);
    vector<pair<int, int>> ks;
    ways = vector<vector<pair<int, int>>>(n);
    sums = vector<int>(n);
    for (int i = 0; i < n-1; i++)
    {
        int ai, bi, ci;
        cin >> ai >> bi >> ci;
        ai--;
        bi--;
        ways[ai].push_back(pair<int, int>(bi, ci));
        ways[bi].push_back(pair<int, int>(ai, ci));
        sums[ai] += ci;
        sums[bi] += ci;
        allsum += ci;
    }
    for (int i = 0; i < m; i++)
    {
        int inp;
        cin >> inp;
        ks.push_back(pair<int,int>(inp,i));
    }
    sort(ks.begin(), ks.end(), greater<pair<int, int>>());
    vector<bool> used = vector<bool>(m);
    int fs = 0;
    int cnt = 0;
    while (made != m)
    {
        for (int i = fs; i < ks.size(); i++)
        {
            if ((!used[i])&&(ks[i].first >= allsum))
            {
                made++;
                xs[ks[i].second] = cnt;
                fs = i+1;
                used[i] = true;
            }
            else break;
        }
        if (made != m) 
        {
            int id = max_element(sums.begin(), sums.end()) - sums.begin();
            for (int i = 0; i < ways[id].size(); i++)
            {
                sums[ways[id][i].first] -= ways[id][i].second;
            }
            allsum -= sums[id];
            sums[id] = 0;
            cnt++;
        }
    }

    for (int i = 0; i < xs.size(); i++)
    {
        cout << cnt << " ";
    }
}
