#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k, g, tmp;
    cin >> n >> k >> g;
    if (g == 3) {
        int crossroad = 1;
        k--;
        if (k % 2 == 0) {
            cout << k / 2 << ' ' << k / 2 << endl;
            for (int i = 0; i < k / 2; ++i) {
                cout << i + 2 << ' ';
            }
            cout << endl;
            cout << crossroad << endl;
            for (int i = 0; i < k / 2; ++i) {
                cout << i + k / 2 + 2 << ' ';
            }
        } else {
            cout << k / 2 << ' ' << k / 2 + 1 << endl;
            for (int i = 0; i < k / 2; ++i) {
                cout << i + 2 << ' ';
            }
            cout << endl;
            cout << crossroad << endl;
            for (int i = 0; i < k / 2 + 1; ++i) {
                cout << i + k / 2 + 2 << ' ';
            }
        }
    } else if (g == 4 || g == 5) {
        if (n < 7) {
            cout << -1;
            return 0;
        }
        int one = 0;
        int two = 0;
        int crossroad;

        for (int i = 0; i < n; ++i) {
            cin >> tmp;
            if (tmp == 1) one++;
            else two++;
        }
        if (abs(one - two) > 1 || one == two) {
            cout << -1;
            return 0;
        }
        int oneOrTwo = 2;
        int twoOrOne = 1;
        int more = one;
        int less = two;
        if (one < two) {
            more = two;
            oneOrTwo = 1;
            twoOrOne = 2;
            less = one;
        }
        crossroad = oneOrTwo;
        less--;
        cout << 3 << ' ' << less + more - 3 << endl;
        cout << twoOrOne << ' ' << oneOrTwo << ' ' << twoOrOne << endl;
        cout << crossroad << endl;
        for (int i = 0; i < less + more - 3; ++i) {
            if (i % 2 == 0) {
                cout << twoOrOne << ' ';
            } else {
                cout << oneOrTwo << ' ';
            }
        }
    } else if (g == 2) {
        if (k == 2) {
            cout << -1;
            return 0;
        }
        vector<int> v(n, 0);
        vector<int> count(k + 1, 0);

        vector<int> upper(k, 0);
        vector<int> bound(k, 0);
        int crossroad = 0;
        int near_crossroad = 0;
        for (int i = 0; i < n; ++i) {
            cin >> v[i];
            count[v[i]]++;
        }
        sort(v.begin(), v.end());

        auto max_el = max_element(count.begin(), count.end());
        int pos = max_el - count.begin();
        int el = *max_el;

        v.erase(remove(v.begin(), v.end(), pos), v.end());

        near_crossroad = v[0];
        v.erase(v.begin());
        crossroad = v[v.size() - 1];
        v.erase(v.end() - 1);

        cout << n / 2 << ' ' << n / 2 - 1 << endl << near_crossroad << ' ';
        auto iter = v.begin() + 1;

        for (int i = 0; i < n / 2 - 2; ++i) {
            if (i % 2 == 0) cout << pos << ' ';
            else {
                cout << *iter << ' ';
                iter++;
            }
        }

        cout <<  endl << crossroad << endl;

        for (int i = 0; i < n / 2 - 3; ++i) {
            if (i % 2 == 0) cout << pos << ' ';
            else {
                cout << *iter << ' ';
                iter++;
            }
        }
    }
}
