import random


def find_right_order(c_arr: list, crossroad=False) -> (bool, int):
    c_arr_copy = c_arr[1:]
    for i, c in enumerate(c_arr_copy):
        if c == c_arr[i]:
            return 0
    del c_arr_copy

    for i, c in enumerate(c_arr):
        if colors[0] != c and colors[-1] != c and colors[i - 1] != c and colors[i + 1] != c and 2 <= i <= len(colors) - 2:
            return 1 if not crossroad else i

    return 0


n, k, g = map(int, input().split())
colors = list(map(int, input().split()))

colors_quan = {}
for c in colors:
    if c not in colors_quan:
        colors_quan.update({c: colors.count(c)})

sorted_keys = sorted(colors_quan.items(), key=lambda item: item[1], reverse=True)
colors_quan = {k: val for k, val in sorted_keys}
keys, values = list(colors_quan.keys()), list(colors_quan.values())

max_quan = values[0]
if max_quan - 1 > sum(values) - max_quan:
    print(-1)
    quit()

while not find_right_order(colors):
    random.shuffle(colors)

cr_r_i = find_right_order(colors, crossroad=True)

print(cr_r_i, len(colors) - cr_r_i - 1)
for c in colors[:cr_r_i]:
    print(c, end=' ')
print()
print(colors[cr_r_i])
for c in colors[cr_r_i + 1:]:
    print(c, end=' ')
