#include <iostream>
#include <vector>

const int N = 3002, M = 2e5;

using namespace std;

int min_v(long long mv[], int n, long long k){
    int l = 0, r = n, m;
    while(l <= r){
        m = l + ((r - l) >> 1);
        if(mv[m] >= k)
            r = m - 1;
        else l = m + 1;
    }
    return r + 1;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, m, gn, ct[N + 1]{}, mv[N + 2], sm = 0;
    cin >> n >> m >> gn;
    vector<pair<int, int>> g[N + 1];
    for(int i = 0, a, b, c; i < n - 1; ++i){
        cin >> a >> b >> c;
        --a; --b;
        sm += c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        ct[a] += c;
        ct[b] += c;
    }
    mv[0] = 0;
    for(int i = 0, mx; i < n; ++i){
        mx = 0;
        for(int j = 1; j < n; ++j)
            if(ct[mx] < ct[j])
                mx = j;
        for(int j = 0; j < g[mx].size(); ++j)
            ct[g[mx][j].first] -= g[mx][j].second;
        mv[i + 1] = mv[i] + ct[mx];
        ct[mx] = 0;
    }
    long long k;
    for(int i = 0; i < m; ++i){
        cin >> k;
        cout << min_v(mv, n, sm - k) << ' ';
    }
}
