#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("avx,avx2,tune=native")
#include <iostream>
#include <iomanip> 
#include <algorithm>
#include <set>
#include <unordered_map>
#include <vector>
#include <bitset>
#include <numeric>
#include <random>
#include <chrono>
#include <deque>
#include <map>
#include <queue>
#include <limits.h>
#define pb push_back
#define all(a) a.begin(),a.end()
#define mp make_pair
#define X first
#define Y second
#define sqr(x) ((x)*(x))
//#define int long long
#define P 31

using namespace std;
//typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;

using namespace std;
using ll = long long;

constexpr int inf = 1000000000 + 10;
constexpr int maxn = 200000 + 10;
//constexpr int mod = 1e9 + 7;

int n;
vector <pii> graph [maxn];
int ver [3333];
int dp[3333][3333][2];

inline void dfs (int v, int par = -1){
    int s = 0;
    dp[v][0][1] = -inf;
    ver[v] = 1;
    for (pii i: graph[v]) if (i.X != par){
        dfs (i.X, v);
        ver[v] += ver[i.X];
        s += i.Y;
    }
    for (pii i: graph[v]) if (i.X != par){
        for (int am2 = ver[v]; am2 > 0; --am2)
            for (int am = max (0, am2 - ver[i.X]); am < am2; ++am){
                dp[v][am2][0] = max (dp[v][am2][0], dp[v][am][0] + dp[i.X][am2 - am][0]);
                dp[v][am2][0] = max (dp[v][am2][0], dp[v][am][0] + dp[i.X][am2 - am][1] + i.Y);
                dp[v][am2][1] = max (dp[v][am2][1], dp[v][am][1] + dp[i.X][am2 - am][0]);
                dp[v][am2][1] = max (dp[v][am2][1], dp[v][am][1] + dp[i.X][am2 - am][1]);
            }
    }
    for (int am2 = 1; am2 <= n; ++am2) dp[v][am2][1] += s;
}

int a [maxn];

inline void solve (int &m, int g){
    int v, u, c, k;
    int s = 0;
    for (int i = 1; i < n; ++i){
        cin >> v >> u >> c;
        graph[v].pb (mp (u, c));
        graph[u].pb (mp (v, c));
        s += c;
    }
    dfs (1);
    for (int i = 0; i <= n; ++i){
        a[i] = s - max (dp[1][i][0], dp[1][i][1]);
    }
    while (m--){
        cin >> k;
        int l = 0, r = n >> 1;
        while (l < r){
            int t_m = (l + r) >> 1;
            if (k < a[t_m]) l = t_m + 1;
            else r = t_m;
        }
        cout << l << ' ';
    }
    cout << '\n';
}

signed main (){
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int m, g;
    cin >> n >> m >> g;
    solve (m, g);
    return 0;
}