#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("avx,avx2,tune=native")
#include <iostream>
#include <iomanip> 
#include <algorithm>
#include <set>
#include <unordered_map>
#include <vector>
#include <bitset>
#include <numeric>
#include <random>
#include <chrono>
#include <deque>
#include <map>
#include <queue>
#include <limits.h>

using namespace std;

using namespace std;
using ll = long long;
using pii = pair <signed, int>;

constexpr int inf = 1000000010;

signed n;
vector <pii> graph [3001];
signed ver [3001];
int dp[3001][3001][2];

inline void dfs (signed v, signed par = 0){
    int s = 0;
    dp[v][0][1] = -inf;
    ver[v] = 1;
    for (pii i: graph[v]) if (i.first != par){
        dfs (i.first, v);
        ver[v] += ver[i.first];
        s += i.second;
    }
    for (pii i: graph[v]) if (i.first != par){
        for (signed am2 = min(ver[v], (n >> 1)); am2 > 0; --am2)
            for (signed am = max (0, am2 - ver[i.first]); am < am2; ++am){
                dp[v][am2][0] = max (dp[v][am2][0], dp[v][am][0] + dp[i.first][am2 - am][0]);
                dp[v][am2][0] = max (dp[v][am2][0], dp[v][am][0] + dp[i.first][am2 - am][1] + i.second);
                dp[v][am2][1] = max (dp[v][am2][1], dp[v][am][1] + dp[i.first][am2 - am][0]);
                dp[v][am2][1] = max (dp[v][am2][1], dp[v][am][1] + dp[i.first][am2 - am][1]);
            }
    }
    for (signed am2 = 1; am2 <= n; ++am2) dp[v][am2][1] += s;
}

int a [3001];

inline void solve (int &m, signed g){
    signed v, u, c;
    int k;
    int s = 0;
    for (signed i = 1; i < n; ++i){
        cin >> v >> u >> c;
        graph[v].push_back (make_pair (u, c));
        graph[u].push_back (make_pair (v, c));
        s += c;
    }
    signed root = (7312 % n) + 1;
    dfs (root);
    for (signed i = 0; i <= (n >> 1); ++i){
        a[i] = s - max (dp[root][i][0], dp[root][i][1]);
    }
    while (m--){
        cin >> k;
        signed l = 0, r = n >> 1;
        while (l < r){
            signed t_m = (l + r) >> 1;
            if (k < a[t_m]) l = t_m + 1;
            else r = t_m;
        }
        cout << l << ' ';
    }
    cout << '\n';
}

signed main (){
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int m, g;
    cin >> n >> m >> g;
    solve (m, g);
    return 0;
}