#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
//#pragma GCC optimize ("avx,avx2,tune=native")
#include <iostream>
#include <iomanip> 
#include <algorithm>
#include <set>
#include <unordered_map>
#include <vector>
#include <bitset>
#include <numeric>
#include <random>
#include <chrono>
#include <deque>
#include <map>
#include <queue>
#include <limits.h>
#define pb push_back
#define all(a) a.begin(),a.end()
#define mp make_pair
#define X first
#define Y second
#define sqr(x) ((x)*(x))
#define int long long
#define P 31

using namespace std;
//typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;

using namespace std;

constexpr int inf = 1e17 + 10;
constexpr int maxn = 3e5 + 10;
constexpr int mod = 1e9 + 7;

set <int> graph[maxn];

struct DSU
{
    int n;
    vector <int> p, am, rank;
    DSU (int _n)
    {
        n = _n;
        rank.assign(n + 1, 1);
        am.assign (n + 1, 1);
        p.resize (n + 1);
        iota (p.begin (), p.end (), 0);
    }
    int get (int x)
    {
        if (p[x] == x) return x;
        return p[x] = get (p[x]);
    }
    void add (int x, int y){
        for (int i: graph[y]) graph[x].insert (i);
    }
    void unite (int x,int y)
    {
        x = get (x), y = get (y);
        if (rank[x] > rank[y]) {
            p[y] = x;
            am[x] += am[y];
            add (x, y);
        } else if (rank[x] < rank[y]) {
            p[x] = y;
            am[y] += am[x];
            add (y, x);
        } else {
            p[y] = x;
            rank[x]++;
            am[x] += am[y];
            add (x, y);
        }
    }
};

vector <int> add;

void solve (int &n, int &q){
    int t, u, v;
    DSU a (n);
    for (int i = 1; i <= n; ++i) graph[i].insert (i);
    while (q--){
        cin >> t >> u >> v;
        if (t == 1){
            u = a.get (u);
            if (v > (int) graph[u].size ()){
                cout << "-1 \n";
                continue;
            }
            add.clear ();
            int res;
            while (v--){
                res = *graph[u].begin ();
                add.pb (res);
                graph[u].erase (res);
            }
            cout << res << '\n';
            for (int i: add) graph[u].insert (i);
            continue;
        }
        a.unite (u, v);
    }
}

signed main (){
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int n, q, g;
    cin >> n >> q >> g;
    solve (n, q);
    return 0;
}