#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, k, g;
    cin >> n >> k >> g;
    vector<int> a(n);
    for (int &i : a) cin >> i;
    if (n <= 6)
    {
        sort(a.begin(), a.end());
        do
        {
            for (int i = 2; i < n - 2; ++i)
            {
                bool flag = true;
                for (int j = 0; j < i; ++j)
                {
                    if (a[j] == a[j + 1])
                    {
                        flag = false;
                        break;
                    }
                }
                if (a[0] == a[i]) flag = false;
                for (int j = i + 1; j < n; ++j)
                {
                    if (a[j] == a[j - 1])
                    {
                        flag = false;
                        break;
                    }
                }
                if (a.back() == a[i]) flag = false;
                if (flag)
                {
                    cout << i << ' ' << n - i - 1 << '\n';
                    for (int j = 0; j < i; ++j) cout << a[j] << ' ';
                    cout << '\n' << a[i] << '\n';
                    for (int j = i + 1; j < n; ++j) cout << a[j] << ' ';
                    return 0;
                }
            }
        } while (next_permutation(a.begin(), a.end()));
        cout << -1;
        return 0;
    }
    if (g == 6)
    {
        random_device rd;
        mt19937 gen(rd());
        for (int kkkk = 0; kkkk < 1e4; ++kkkk)
        {
            shuffle(a.begin(), a.end(), gen);
        for (int i = 2; i < n - 2; ++i)
        {
            bool flag = true;
            for (int j = 0; j < i; ++j)
            {
                if (a[j] == a[j + 1])
                {
                    flag = false;
                    break;
                }
            }
            if (a[0] == a[i]) flag = false;
            for (int j = i + 1; j < n; ++j)
            {
                if (a[j] == a[j - 1])
                {
                    flag = false;
                    break;
                }
            }
            if (a.back() == a[i]) flag = false;
            if (flag)
            {
                cout << i << ' ' << n - i - 1 << '\n';
                for (int j = 0; j < i; ++j) cout << a[j] << ' ';
                cout << '\n' << a[i] << '\n';
                for (int j = i + 1; j < n; ++j) cout << a[j] << ' ';
                return 0;
            }
        }
        }
        cout << -1;
        return 0;
    }
    if (g == 2)
    {
        set<int> help(a.begin(), a.end());
        if (help.size() == 2)
        {
            cout << -1;
            return 0;
        }
        vector<int> counter(k + 1);
        for (int i : a) ++counter[i];
        int ma;
        for (int i = 1; i <= k; ++i)
        {
            if (counter[i] == n / 2)
            {
                ma = i;
                break;
            }
        }
        vector<int> na;
        for (int i = 0; i < n; ++i)
        {
            if (a[i] == ma) continue;
            na.push_back(ma);
            na.push_back(a[i]);
        }
        a = na;
        cout << "3 " << n - 4 << '\n';
        cout << a[0] << ' ' << a[1] << ' ' << a[2] << '\n';
        cout << a.back() << '\n';
        for (int i = 3; i + 1 < n; ++i) cout << a[i] << ' ';
        return 0;
    }
    else if (g == 3)
    {
        cout << "3 " << n - 4 << '\n';
        cout << a[0] << ' ' << a[1] << ' ' << a[2] << '\n';
        cout << a.back() << '\n';
        for (int i = 3; i + 1 < n; ++i) cout << a[i] << ' ';
        return 0;
    }
    if (k == 1)
    {
        cout << -1;
        return 0;
    }
    if (k == 2)
    {
        int cnt1 = (int)count(a.begin(), a.end(), 1);
        int cnt2 = n - cnt1;
        if (cnt1 < cnt2)
        {
            if (cnt1 + 1 != cnt2)
            {
                cout << -1;
                return 0;
            }
            cout << "3 " << n - 4 << '\n';
            cout << "2 1 2\n1\n2";
            for (int i = 0; i < cnt1 - 2; ++i) cout << "1 2";
        }
        else
        {
            if (cnt2 + 1 != cnt1)
            {
                cout << -1;
                return 0;
            }
            cout << "3 " << n - 4 << '\n';
            cout << "1 2 1\n2\n1";
            for (int i = 0; i < cnt1 - 2; ++i) cout << "2 1";
        }
    }
    return 0;
}
