#include <bits/stdc++.h>
using namespace std;

int find_min(int *a, int n)
{
    int min = a[1];
    int index = 1;
    for(int i=1; i<n; i++)
    {
        if( a[i] < min)
        {
            min = a[i];
            index = i;
        }
    }
    return index;
}

int find_not(int *a, int n, int color)
{
    for(int i=1; i<n; i++)
    {
        if( a[i] >0 && i != color)
        {
            return i;
        }
    }
    return -1;
}

int find_not(int *a, int n, int c1, int c2)
{
    for(int i=1; i<n; i++)
    {
        if( a[i] >0 && i != c1 && i != c2)
        {
            return i;
        }
    }
    return -1;
}

int main()
{
    int n/*кількість ліхтарів*/, k/*кількість кольорів*/, g;
    cin >> n >> k >> g;
    int lighters[n];
    for(int i=0; i<n; i++)
    {
        cin >> lighters[i];
    }
    int colors[k+1];
    for(int i=0; i<k+1; i++)
    {
        colors[i] = 0;
    }
    for(int i=0; i<n; i++)
    {
        colors[lighters[i]]++;
    }
    for(int i=0; i<k+1; i++)
    {
       // cout <<i<<"="<< colors[i] << endl;
    }
    int min = find_min(colors, k+1);
 //   cout <<"min="<< min << endl;

    int x=0;//lighters in top
    int y=0;//lighters in bottom
    int central_color=0;//color of the central lighter
    int top[n];
    int bottom[n];

    central_color = min;
    colors[min]--;
    n--;
    while(n>0)
    {
        int next = find_not(colors, k+1, min);
     //   cout <<"next top="<< next << endl;
        if(next == -1)
        {
            cout<<-1 << endl;
            return 0;
        }
        top[x] = next;
        x++;
        colors[next]--;
        n--;

        next = find_not(colors, k+1, next, central_color);
  //      cout <<"next top="<< next << endl;
        if(next == -1)
        {
            cout<<-1 << endl;
            return 0;
        }
        top[x] = next;
        x++;
        colors[next]--;
        n--;
        //=----bottom-------------------------
        next = find_not(colors, k+1, min);
     //   cout <<"next bottom="<< next << endl;
        if(next == -1)
        {
            cout<<-1 << endl;
            return 0;
        }
        bottom[y] = next;
        y++;
        colors[next]--;
        n--;

        next = find_not(colors, k+1, next, central_color);
      //  cout <<"next bottom="<< next << endl;
        if(next == -1)
        {
            cout<<-1 << endl;
            return 0;
        }
        bottom[y] = next;
        y++;
        colors[next]--;
        n--;
    }

    cout << x<<' ' << y<< endl;
    for(int i=0; i<x; i++)
    {
        cout << top[i]<<' ';
    }
    cout << endl;
    cout << central_color << endl;
    for(int i=0; i<y; i++)
    {
        cout << bottom[i]<<' ';
    }
    cout << endl;
}