#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void input(pair<ll, vector<pair<ll, vector<pair<ll, int>>>>> &tree, int n) {
    tree.first = 0;
    tree.second.resize(n+1, {0, {}});
    int v1, v2, val;
    for (int i = 1; i < n; i++) {
        cin >> v1 >> v2 >> val;
        tree.first += val;
        tree.second[v1].first += val; tree.second[v2].first += val;
        tree.second[v1].second.push_back(make_pair(val, v2));
        tree.second[v2].second.push_back(make_pair(val, v1));
    }
}


int getMax(pair<ll, vector<pair<ll, vector<pair<ll, int>>>>> tree) {
    int n = tree.second.size(), max = 1;
    for (int i = 1; i < n; i++) {
        if (tree.second[i].first > tree.second[max].first) max = i;
    }
    return max;
}


void turnOff(pair<ll, vector<pair<ll, vector<pair<ll, int>>>>> &tree, int vert) {
    int val = tree.second[vert].first;
    tree.first -= val;
    for (pair<int, int> v : tree.second[vert].second) {
        tree.second[v.second].first -= v.first;
    }
}


int getAns(pair<ll, vector<pair<ll, vector<pair<ll, int>>>>> tree, int light) {
    int cnt = 0, vert;
    while (tree.first > light) {
        vert = getMax(tree);
        turnOff(tree, vert);
        cnt++;
    }
    return cnt;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    pair<ll, vector<pair<ll, vector<pair<ll, int>>>>> tree; int n, query, val;
    cin >> n >> query >> val;
    input(tree, n);

    for (int i = 0; i < query; i++) {
        cin >> val;
        cout << getAns(tree, val) << " ";
    }

    return 0;
}