#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<pair<int,int>> v;
vector<int> y;
vector<int> x;

bool comp(pair<int, int> p1, pair<int, int> p2) 
{
    return p1.first > p2.first;
}

void work1(int&i, int j)
{
    while (1) {
        if (x[i] == 0 && x[i - 1] != v[j].second) {
            x[i] = v[j].second;
            v[j].first--;
            break;
        }
        else {
            i++;
        }
    }
}

void work2(int n)
{
    y.push_back(v[0].second);
    y.push_back(v[1].second);
    v[0].first--;
    v[1].first--;
    sort(v.begin(), v.end(), comp);
    if (n > 5) {
        y.push_back(v[0].second);
        v[0].first--;
        sort(v.begin(), v.end(), comp);
    }

}

void work4(int& r, int& i)
{
    if (v[r].first >= v[r + 1].first) {
        y[i] = v[r].second;
        v[r].first--;
        return;
    }
    r++;
    i -= 2;
    return;
}

void work3(int k)
{
    y.push_back(0);
    while (v[k - 1].first > 0) {
        y.push_back(v[k - 1].second);
        y.push_back(0);
        v[k - 1].first--;
    }
    int r = 0;
    for (int i = 0; i < y.size(); i += 2) {
        if (r == 0){
            work4(r, i);
        }
        else {
            if (v[r].first > v[r - 1].first) {
                y[i] = v[r].second;
                v[r].first--;
            }
            else if(y[i-2]==v[r].second) {
                r++;
            }
            else {
                r = 0;
            }
        }
    }
}

void solve()
{
    int n, k, g;
    cin >> n >> k >> g;
    v.resize(k, { 0,0 });
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        v[a-1].first++;
        v[a-1].second = a;
    }
    if (k == 1) {
        cout << -1;
        return;
    }

    sort(v.begin(), v.end(),comp);
    if (k == 2) {
        if (n == 5 || v[0].first != v[1].first + 1) {
            cout << -1;
            return;
        }
    }
    int a = v[k-1].second;
    v[k-1].first--;
    sort(v.begin(), v.end(), comp);
    if (v[k - 1].first == 0) {
        work2(n);
    }
    else {
        work3(k);
    }
    sort(v.begin(), v.end(), comp);

    int r = n - 1 - y.size();
    x.resize(r, 0);
    int i = 0;
    if (v[0].first > (r / 2 + 1)) {
        cout << -1;
        return;
    }
    while (v[0].first > 0) {
        while (v[0].first>=v[1].first && v[0].first>0) {
            int j = i;
            if (i == 0) {
                v[0].first--;
                x[0] = v[0].second;
                i++;
            }
            else {
                work1(j, 0);
            }
        }

        for (int j = 1; j < k; j++) {
            if (v[j].first > v[j - 1].first) {
                work1(i,j);
            }
            else {
                break;
            }
        }
    }
    if (x.size() == 0) {
        cout << -1;
        return;
    }
    if (x.size() == 1) {
        int z = y.size();
        x.push_back(y[z - 2]);
        x.push_back(y[z - 1]);
        y.pop_back();
        y.pop_back();
    }
    cout << x.size() << " " << y.size() << LF;
    for (int i = 0; i < x.size(); i++) cout << x[i] << " ";
    cout << LF;
    cout << a << LF;
    for (int i = 0; i < y.size(); i++) cout << y[i] << " ";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

