#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<vector<pair<int,int>>> graf;
vector<lli> cnt;
vector<lli> a;

int maxx()
{
    lli mx=1;
    int x=-1;
    for (int i = 0; i < cnt.size(); i++) {
        if (mx < cnt[i]) {
            mx = cnt[i];
            x = i;
        }
    }
    return x;
}

void work(lli s)
{
    a.push_back(s); 
    while (maxx() != -1) {
        int x = maxx();
        s -= cnt[x];
        a.push_back(s);
        cnt[x] = 0;
        for (int i = 0; i < graf[x].size(); i++) {
            cnt[graf[x][i].first] -= graf[x][i].second;
        }
    }
}

void solve(int n, lli s)
{
    lli k;
    cin >> k;
    for (int i = 0; i < a.size(); i++) {
        if (a[i] <= k) {
            cout << i << " ";
            return;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    lli n,m,g;
    cin >> n >> m >> g;
    graf.resize(n);
    lli s = 0;
    cnt.resize(n, 0);
    for (int i = 0; i < n-1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        graf[a-1].push_back({ b-1, c });
        graf[b-1].push_back({ a-1,c });
        s += c;
        cnt[a-1] += c;
        cnt[b-1] += c;
    }
    work(s);
    while(m--) solve(n,s);
}

