#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<vector<int>> graf;
vector<int> used;
vector<int> a;
int n, p, g;

void dfs(int u)
{
    if (used[u] != 1) {
        used[u] = 1;
        a.push_back(u);
        for (int i = 0; i < graf[u].size(); i++) {
            dfs(graf[u][i]);
        }
    }
}

void work1(int u, int k)
{
    used.clear();
    used.resize(n + 1, 0);
    a.clear();
    dfs(u);
    sort(a.begin(), a.end());
    if (k > a.size()) {
        cout << -1 << LF;
        return;
    }
    cout << a[k - 1] << LF;
}

void solve()
{
    int a, u, k;
    cin >> a >> u >> k;
    if (a == 1) {
        work1(u, k);
    }
    else {
        graf[u].push_back(k);
        graf[k].push_back(u);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> p >> g;
    graf.resize(n + 1);
    while(p--) solve();
}

