#include <bits/stdc++.h>

using namespace std;

const int N = 1e6;
int p[N];
vector<int> l[N];

void make_set(int i) {
    p[i] = i;
    l[i].push_back(i);
}

int find_set(int i) {
    if (p[i] == i) {
        return i;
    }
    return p[i] = find_set(p[i]);
}

void union_set(int a, int b) {
    if (l[a].size() < l[b].size()) {
        swap(a, b);
    } // sz[a] >= sz[b]
    p[b] = a;
    for (auto i : l[b]) {
        l[a].push_back(i);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, tt;
    cin >> n >> q >> tt;
    for (int i = 0; i < n; ++i) {
        make_set(i);
    }
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int i, k;
            cin >> i >> k;
            --i, --k;
            i = find_set(i);
            sort(l[i].begin(), l[i].end());
            if (k >= l[i].size()) {
                cout << -1 << '\n';
            } else {
                cout << l[i][k] + 1 << '\n';
            }
        } else if (type == 2) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            union_set(find_set(u), find_set(v));
        }
    }
    return 0;
}
