#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e6;
int p[N];
ordered_set l[N];
pair<int, int> lastP[N];
vector<pair<int, int>> added[N];
bool was[N] = {};
int t = 0;

void make_set(int i) {
    p[i] = i;
    l[i].insert(i);
}

int find_set(int i) {
    if (p[i] == i) {
        return i;
    }
    return find_set(p[i]);
}

void union_set(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a == b) {
        return;
    }
    was[t] = true;
    if (l[a].size() < l[b].size()) {
        swap(a, b);
    } // sz[a] >= sz[b]
    lastP[t] = {b, b};
    p[b] = a;
    for (auto i : l[b]) {
        l[a].insert(i);
        added[t].push_back({a, i});
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, tt;
    cin >> n >> q >> tt;
    for (int i = 1; i <= n; ++i) {
        make_set(i);
    }
    for (int qq = 0; qq < q; ++qq, ++t) {
        int type;
        cin >> type;
        if (type == 1) {
            int i, k;
            cin >> i >> k;
            --k;
            i = find_set(i);
            if (k >= l[i].size()) {
                cout << -1 << '\n';
            } else {
                cout << *l[i].find_by_order(k) << '\n';
            }
        } else if (type == 2) {
            int u, v;
            cin >> u >> v;
            union_set(u, v);
        } else {
            int x;
            cin >> x;
            --x;
            for (int i = t - 1; i >= x + 1; --i) {
                if (!was[i]) {
                    continue;
                }
                p[lastP[i].first] = lastP[i].second;
                for (auto [ind, val] : added[i]) {
                    l[ind].erase(val);
                    //cout << ind << ' ' << val << '\n';
                }
                added[i].clear();
                was[i] = false;
            }
            //t = x;
        }
    }
    return 0;
}