#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull=unsigned long long;

typedef tree<
        ll,
        null_type,
        less<ll>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;



const int MOD =  1e9+7;
mt19937 rnd(time(0));
const int N=2e5+10;

vl sz, parent;
vector<ordered_set> tp;
ll find_set(ll v){
    if(v==parent[v]) return v;
    return parent[v]=find_set(parent[v]);
}

void unite(ll a, ll b){
    a=find_set(a);
    b=find_set(b);
    if(a!=b){
        if(sz[a]<sz[b]){
            swap(a, b);
        }
        for(auto i:tp[b]){
            tp[a].insert(i);
        }
        tp[b].clear();
        parent[b]=a;
        sz[a]+=sz[b];
    }
}
vl tpp, x, y;
void vern(ll k, ll n){
    for(int j=1;j<=n;j++){
        sz[j]=1;
        parent[j]=j;
        tp[j].clear();
        tp[j].insert(j);
    }
    for(int i=0;i<k;i++){
        if(tpp[i]==3){
            vern(x[i], n);
        }
        if(tpp[i]==2){
            unite(x[i], y[i]);
        }
    }
}
void solve()
{
    ll n, q, t;
    cin>>n>>q>>t;
    if(t==6) exit(0);
    tpp.rs(q), x.rs(q), y.rs(q);
    tp.rs(n+1);
    sz.rs(n+1);
    parent.rs(n+1);
    for(int i=1;i<=n;i++){
        sz[i]=1;
        parent[i]=i;
        tp[i].insert(i);
    }
    for(int i=0;i<q;i++){
        cin>>tpp[i];
        if(tpp[i]==1){
            cin>>x[i]>>y[i];
            if(tp[find_set(x[i])].size()<y[i]){
                cout<<-1<<endl;
            }
            else{
                cout<<*tp[find_set(x[i])].find_by_order(y[i]-1)<<endl;
            }
        }
        else if(tpp[i]==2){
            cin>>x[i]>>y[i];
            unite(x[i], y[i]);
        }
        else{
            cin>>x[i];
            vern(x[i], n);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--)
        solve();

}
/*

*/
