#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>

const int N = 3005;
const int M = 200000;
int n, m, G, d[N][N][2], next[N][2], size[N], ans[M];
std::vector<std::pair<int, int> > g[N];
std::pair<int, int> q[M];

void dfs(int v, int pr = -1) {
	d[v][0][1] = ~(1 << 31) >> 2;
	size[v] = 1;
	for (int i = 0; i < (int)g[v].size(); ++i) if (g[v][i].first != pr) {
		int to = g[v][i].first, w = g[v][i].second;
		dfs(to, v);
		memset(*next, 0x3f, size[to] + 1 << 3);
		for (int j = 0; j <= size[v]; ++j) {
			for (int k = 0; k <= size[to]; ++k) {
				next[j + k][0] = std::min(next[j + k][0], d[to][j][0] + d[v][k][0] + w);
				next[j + k][0] = std::min(next[j + k][0], d[to][j][1] + d[v][k][0]);
				next[j + k][1] = std::min(next[j + k][1], d[to][j][0] + d[v][k][1]);
			}
		}
		size[v] += size[to];
		for (int i = 0; i <= size[v]; ++i) {
			d[v][i][1] = next[i][1];
			d[v][i][0] = std::min(d[v][i][1], next[i][0]);
		}
	}
}

int main() {
	scanf("%d%d%d", &n, &m, &G);
	for (int i = 1; i < n; ++i) {
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		--a;
		--b;
		g[a].push_back(std::make_pair(b, c));
		g[b].push_back(std::make_pair(a, c));
	}
	dfs(0);
	for (int i = 0; i < m; ++i) {
		scanf("%d", &q[i].first);
		q[i].second = i;
	}
	std::sort(q, q + m);
	for (int i = m - 1, j = 0; i >= 0; --i) {
		while (d[0][j][0] > q[i].first) ++j;
		ans[q[i].second] = j;
	}
	for (int i = 0; i < m; ++i) printf("%d ", ans[i]);
	printf("\n");
	return 0;
}
